/* Terminal.c generated by valac 0.56.17, the Vala compiler
 * generated from Terminal.vala, do not modify */

/* Terminal.vala
 *
 * Copyright 2020-2022 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#define _GNU_SOURCE

#include <vte/vte.h>
#include <glib-object.h>
#include <adwaita.h>
#include <glib.h>
#include <gio/gio.h>
#include <pqmarble.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <pcre2.h>
#include <pango/pango.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>
#include <glib/gi18n-lib.h>

#define TERMINAL_APP_NAME "BlackBox"
#define TERMINAL_CONSTANTS_SCHEME "(?:news:|telnet:|nntp:|file:|https?:|ftps?:|sftp:|webcal:" "|irc:|sftp:|ldaps?:|nfs:|smb:|rsync:|ssh:|rlogin:|telnet:|git:" "|git\\+ssh:|bzr:|bzr\\+ssh:|svn:|svn\\+ssh:|hg:|mailto:|magnet:)"
#define TERMINAL_CONSTANTS_USERCHARS "-[:alnum:]"
#define TERMINAL_CONSTANTS_USERCHARS_CLASS "[" TERMINAL_CONSTANTS_USERCHARS "]"
#define TERMINAL_CONSTANTS_PASSCHARS_CLASS "[-[:alnum:]\\Q,?;.:/!%$^*&~\"#'\\E]"
#define TERMINAL_CONSTANTS_USERPASS TERMINAL_CONSTANTS_USERCHARS_CLASS "+(?:" TERMINAL_CONSTANTS_PASSCHARS_CLASS "+)?"
#define TERMINAL_CONSTANTS_HOSTCHARS_CLASS "[-[:alnum:]]"
#define TERMINAL_CONSTANTS_HOST TERMINAL_CONSTANTS_HOSTCHARS_CLASS "+(\\." TERMINAL_CONSTANTS_HOSTCHARS_CLASS "+)*"
#define TERMINAL_CONSTANTS_PORT "(?:\\:[[:digit:]]{1,5})?"
#define TERMINAL_CONSTANTS_PATHCHARS_CLASS "[-[:alnum:]\\Q_$.+!*,;:@&=?/~#%\\E]"
#define TERMINAL_CONSTANTS_PATHTERM_CLASS "[^\\Q]'.}>) \t\r\n,\"\\E]"
#define TERMINAL_CONSTANTS_URLPATH "(?:(/" TERMINAL_CONSTANTS_PATHCHARS_CLASS "+(?:[(]" TERMINAL_CONSTANTS_PATHCHARS_CLASS "*[)])*" TERMINAL_CONSTANTS_PATHCHARS_CLASS "*)*" TERMINAL_CONSTANTS_PATHTERM_CLASS ")?"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TERMINAL_TYPE_TERMINAL (terminal_terminal_get_type ())
#define TERMINAL_TERMINAL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_TERMINAL, TerminalTerminal))
#define TERMINAL_TERMINAL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_TERMINAL, TerminalTerminalClass))
#define TERMINAL_IS_TERMINAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_TERMINAL))
#define TERMINAL_IS_TERMINAL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_TERMINAL))
#define TERMINAL_TERMINAL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_TERMINAL, TerminalTerminalClass))

typedef struct _TerminalTerminal TerminalTerminal;
typedef struct _TerminalTerminalClass TerminalTerminalClass;
typedef struct _TerminalTerminalPrivate TerminalTerminalPrivate;

#define TERMINAL_TYPE_WINDOW (terminal_window_get_type ())
#define TERMINAL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_WINDOW, TerminalWindow))
#define TERMINAL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_WINDOW, TerminalWindowClass))
#define TERMINAL_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_WINDOW))
#define TERMINAL_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_WINDOW))
#define TERMINAL_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_WINDOW, TerminalWindowClass))

typedef struct _TerminalWindow TerminalWindow;
typedef struct _TerminalWindowClass TerminalWindowClass;

#define TERMINAL_TYPE_SCHEME (terminal_scheme_get_type ())
#define TERMINAL_SCHEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_SCHEME, TerminalScheme))
#define TERMINAL_SCHEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_SCHEME, TerminalSchemeClass))
#define TERMINAL_IS_SCHEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_SCHEME))
#define TERMINAL_IS_SCHEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_SCHEME))
#define TERMINAL_SCHEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_SCHEME, TerminalSchemeClass))

typedef struct _TerminalScheme TerminalScheme;
typedef struct _TerminalSchemeClass TerminalSchemeClass;

#define TERMINAL_TYPE_PROCESS (terminal_process_get_type ())
#define TERMINAL_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_PROCESS, TerminalProcess))
#define TERMINAL_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_PROCESS, TerminalProcessClass))
#define TERMINAL_IS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_PROCESS))
#define TERMINAL_IS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_PROCESS))
#define TERMINAL_PROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_PROCESS, TerminalProcessClass))

typedef struct _TerminalProcess TerminalProcess;
typedef struct _TerminalProcessClass TerminalProcessClass;

#define TERMINAL_TYPE_SETTINGS (terminal_settings_get_type ())
#define TERMINAL_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_SETTINGS, TerminalSettings))
#define TERMINAL_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_SETTINGS, TerminalSettingsClass))
#define TERMINAL_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_SETTINGS))
#define TERMINAL_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_SETTINGS))
#define TERMINAL_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_SETTINGS, TerminalSettingsClass))

typedef struct _TerminalSettings TerminalSettings;
typedef struct _TerminalSettingsClass TerminalSettingsClass;
enum  {
	TERMINAL_TERMINAL_0_PROPERTY,
	TERMINAL_TERMINAL_SCHEME_PROPERTY,
	TERMINAL_TERMINAL_PID_PROPERTY,
	TERMINAL_TERMINAL_PROCESS_PROPERTY,
	TERMINAL_TERMINAL_ID_PROPERTY,
	TERMINAL_TERMINAL_NEEDS_ATTENTION_PROPERTY,
	TERMINAL_TERMINAL_USER_SCROLLBACK_LINES_PROPERTY,
	TERMINAL_TERMINAL_NUM_PROPERTIES
};
static GParamSpec* terminal_terminal_properties[TERMINAL_TERMINAL_NUM_PROPERTIES];
typedef enum  {
	TERMINAL_TERMINAL_DROP_TARGETS_URILIST,
	TERMINAL_TERMINAL_DROP_TARGETS_STRING,
	TERMINAL_TERMINAL_DROP_TARGETS_TEXT
} TerminalTerminalDropTargets;

#define TERMINAL_TERMINAL_TYPE_DROP_TARGETS (terminal_terminal_drop_targets_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TERMINAL_TYPE_THEME_PROVIDER (terminal_theme_provider_get_type ())
#define TERMINAL_THEME_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_THEME_PROVIDER, TerminalThemeProvider))
#define TERMINAL_THEME_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_THEME_PROVIDER, TerminalThemeProviderClass))
#define TERMINAL_IS_THEME_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_THEME_PROVIDER))
#define TERMINAL_IS_THEME_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_THEME_PROVIDER))
#define TERMINAL_THEME_PROVIDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_THEME_PROVIDER, TerminalThemeProviderClass))

typedef struct _TerminalThemeProvider TerminalThemeProvider;
typedef struct _TerminalThemeProviderClass TerminalThemeProviderClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GdkFileList_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkFileList_free (var), NULL)))
#define _vte_regex_unref0(var) ((var == NULL) ? NULL : (var = (vte_regex_unref (var), NULL)))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define __vala_GdkRGBA_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkRGBA_free (var), NULL)))
typedef struct _TerminalThemeProviderPrivate TerminalThemeProviderPrivate;

#define TERMINAL_TYPE_PADDING (terminal_padding_get_type ())
typedef struct _TerminalPadding TerminalPadding;
#define _gdk_event_unref0(var) ((var == NULL) ? NULL : (var = (gdk_event_unref (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
typedef enum  {
	TERMINAL_PROCESS_CONTEXT_DEFAULT,
	TERMINAL_PROCESS_CONTEXT_ROOT,
	TERMINAL_PROCESS_CONTEXT_SSH
} TerminalProcessContext;

#define TERMINAL_TYPE_PROCESS_CONTEXT (terminal_process_context_get_type ())

#define TERMINAL_TYPE_PROCESS_WATCHER (terminal_process_watcher_get_type ())
#define TERMINAL_PROCESS_WATCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_PROCESS_WATCHER, TerminalProcessWatcher))
#define TERMINAL_PROCESS_WATCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_PROCESS_WATCHER, TerminalProcessWatcherClass))
#define TERMINAL_IS_PROCESS_WATCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_PROCESS_WATCHER))
#define TERMINAL_IS_PROCESS_WATCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_PROCESS_WATCHER))
#define TERMINAL_PROCESS_WATCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_PROCESS_WATCHER, TerminalProcessWatcherClass))

typedef struct _TerminalProcessWatcher TerminalProcessWatcher;
typedef struct _TerminalProcessWatcherClass TerminalProcessWatcherClass;
typedef void (*TerminalHostCommandExitedCallback) (guint pid, guint status, gpointer user_data);
typedef struct _TerminalTerminalSpawnOnFlatpakData TerminalTerminalSpawnOnFlatpakData;
typedef struct _TerminalTerminalGetCanCloseData TerminalTerminalGetCanCloseData;
typedef struct _TerminalTerminalDoPasteFromSelectionClipboardData TerminalTerminalDoPasteFromSelectionClipboardData;
typedef enum  {
	TERMINAL_WORKING_DIRECTORY_MODE_PREVIOUS_SESSION = 0,
	TERMINAL_WORKING_DIRECTORY_MODE_HOME_DIRECTORY = 1,
	TERMINAL_WORKING_DIRECTORY_MODE_CUSTOM = 2
} TerminalWorkingDirectoryMode;

#define TERMINAL_TYPE_WORKING_DIRECTORY_MODE (terminal_working_directory_mode_get_type ())
typedef enum  {
	TERMINAL_SCROLLBACK_MODE_FIXED = 0,
	TERMINAL_SCROLLBACK_MODE_UNLIMITED = 1,
	TERMINAL_SCROLLBACK_MODE_DISABLED = 2
} TerminalScrollbackMode;

#define TERMINAL_TYPE_SCROLLBACK_MODE (terminal_scrollback_mode_get_type ())
enum  {
	TERMINAL_TERMINAL_EXIT_SIGNAL,
	TERMINAL_TERMINAL_SPAWN_FAILED_SIGNAL,
	TERMINAL_TERMINAL_CONTEXT_CHANGED_SIGNAL,
	TERMINAL_TERMINAL_NUM_SIGNALS
};
static guint terminal_terminal_signals[TERMINAL_TERMINAL_NUM_SIGNALS] = {0};

struct _TerminalTerminal {
	VteTerminal parent_instance;
	TerminalTerminalPrivate * priv;
	TerminalWindow* window;
};

struct _TerminalTerminalClass {
	VteTerminalClass parent_class;
};

struct _TerminalTerminalPrivate {
	TerminalScheme* _scheme;
	GPid _pid;
	TerminalProcess* _process;
	guint _id;
	gboolean _needs_attention;
	guint original_scrollback_lines;
	GCancellable* fp_spawn_host_command_callback_cancellable;
	guint attention_timer;
	TerminalSettings* settings;
	GtkCssProvider* padding_provider;
};

struct _TerminalThemeProvider {
	GObject parent_instance;
	TerminalThemeProviderPrivate * priv;
	GHashTable* themes;
};

struct _TerminalThemeProviderClass {
	GObjectClass parent_class;
};

struct _TerminalPadding {
	guint top;
	guint right;
	guint bottom;
	guint left;
};

struct _TerminalTerminalSpawnOnFlatpakData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TerminalTerminal* self;
	VtePtyFlags flags;
	gchar* cwd;
	GArray* argv;
	GArray* envv;
	GPid p;
	gboolean result;
	VtePty* _ppty;
	VtePty* _tmp0_;
	VtePty* _tmp1_;
	VtePty* _tmp2_;
	GError* e;
	GError* _tmp3_;
	const gchar* _tmp4_;
	gint pty_master;
	VtePty* _tmp5_;
	gint* pty_slaves;
	gint* _tmp6_;
	gint pty_slaves_length1;
	gint _pty_slaves_size_;
	const gchar* _tmp7_;
	gint* _tmp8_;
	gint _tmp8__length1;
	gint _tmp9_;
	gint* _tmp10_;
	gint _tmp10__length1;
	gint _tmp11_;
	gint* _tmp12_;
	gint _tmp12__length1;
	gint _tmp13_;
	GCancellable* _tmp14_;
	gboolean res;
	gint* _tmp15_;
	gint _tmp15__length1;
	GCancellable* _tmp16_;
	gint _tmp17_;
	gboolean _tmp18_;
	VtePty* _tmp19_;
	GError* _inner_error0_;
};

struct _TerminalTerminalGetCanCloseData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TerminalTerminal* self;
	gchar* command;
	gboolean result;
	gboolean _tmp0_;
	GPid _tmp1_;
	VtePty* _tmp2_;
	VtePty* _tmp3_;
	gint fd;
	VtePty* _tmp4_;
	VtePty* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint fgpid;
	GPid _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
};

struct _TerminalTerminalDoPasteFromSelectionClipboardData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TerminalTerminal* self;
	GdkClipboard* clipboard;
	GdkDisplay* _tmp0_;
	GdkClipboard* _tmp1_;
	GdkClipboard* _tmp2_;
	gchar* text;
	gchar* _tmp3_;
	GError* e;
	GError* _tmp4_;
	const gchar* _tmp5_;
	GError* _inner_error0_;
};

static gint TerminalTerminal_private_offset;
static gpointer terminal_terminal_parent_class = NULL;
static gchar** terminal_terminal_blackbox_envv;
static gint terminal_terminal_blackbox_envv_length1;
static gchar** terminal_terminal_blackbox_envv = NULL;
static gint terminal_terminal_blackbox_envv_length1 = 0;
static gint _terminal_terminal_blackbox_envv_size_ = 0;
static guint terminal_terminal_next_id;
static guint terminal_terminal_next_id = (guint) 0;

VALA_EXTERN GType terminal_terminal_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalTerminal, g_object_unref)
VALA_EXTERN GType terminal_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalWindow, g_object_unref)
VALA_EXTERN GType terminal_scheme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalScheme, g_object_unref)
VALA_EXTERN GType terminal_process_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalProcess, g_object_unref)
VALA_EXTERN GType terminal_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalSettings, g_object_unref)
static GType terminal_terminal_drop_targets_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN gchar* terminal_constants_get_user_schemes_dir (void);
VALA_EXTERN TerminalTerminal* terminal_terminal_new (TerminalWindow* window,
                                         const gchar* command,
                                         const gchar* cwd);
VALA_EXTERN TerminalTerminal* terminal_terminal_construct (GType object_type,
                                               TerminalWindow* window,
                                               const gchar* command,
                                               const gchar* cwd);
static void terminal_terminal_set_id (TerminalTerminal* self,
                               guint value);
static void terminal_terminal_on_child_exited (TerminalTerminal* self,
                                        gint status);
static void _terminal_terminal_on_child_exited_vte_terminal_child_exited (VteTerminal* _sender,
                                                                   gint status,
                                                                   gpointer self);
VALA_EXTERN TerminalSettings* terminal_settings_get_default (void);
VALA_EXTERN GType terminal_theme_provider_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalThemeProvider, g_object_unref)
VALA_EXTERN TerminalThemeProvider* terminal_theme_provider_get_default (void);
static void terminal_terminal_on_theme_changed (TerminalTerminal* self);
static void _terminal_terminal_on_theme_changed_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void terminal_terminal_on_font_changed (TerminalTerminal* self);
static void _terminal_terminal_on_font_changed_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void terminal_terminal_on_padding_changed (TerminalTerminal* self);
static void _terminal_terminal_on_padding_changed_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static void terminal_terminal_setup_drag_drop (TerminalTerminal* self);
static void terminal_terminal_setup_regexes (TerminalTerminal* self);
static void terminal_terminal_connect_signals (TerminalTerminal* self);
static void terminal_terminal_bind_data (TerminalTerminal* self);
static void terminal_terminal_spawn (TerminalTerminal* self,
                              const gchar* command,
                              const gchar* cwd,
                              GError** error);
static void terminal_terminal_real_dispose (GObject* base);
static gboolean terminal_terminal_on_drag_data_received (TerminalTerminal* self,
                                                  GtkDropTarget* target,
                                                  GValue* value,
                                                  gdouble x,
                                                  gdouble y);
static gboolean _terminal_terminal_on_drag_data_received_gtk_drop_target_drop (GtkDropTarget* _sender,
                                                                        GValue* value,
                                                                        gdouble x,
                                                                        gdouble y,
                                                                        gpointer self);
static GdkFileList* _vala_GdkFileList_copy (GdkFileList* self);
static void _vala_GdkFileList_free (GdkFileList* self);
VALA_EXTERN const gchar* terminal_settings_get_font (TerminalSettings* self);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static void terminal_terminal_get_background_color (TerminalTerminal* self,
                                             TerminalScheme* theme,
                                             GdkRGBA* result);
VALA_EXTERN GdkRGBA* terminal_scheme_get_background_color (TerminalScheme* self);
VALA_EXTERN guint terminal_settings_get_opacity (TerminalSettings* self);
static void _vala_GdkRGBA_free (GdkRGBA* self);
VALA_EXTERN const gchar* terminal_theme_provider_get_current_theme (TerminalThemeProvider* self);
VALA_EXTERN GdkRGBA* terminal_scheme_get_foreground_color (TerminalScheme* self);
VALA_EXTERN GArray* terminal_scheme_get_palette (TerminalScheme* self);
VALA_EXTERN GType terminal_padding_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TerminalPadding* terminal_padding_dup (const TerminalPadding* self);
VALA_EXTERN void terminal_padding_free (TerminalPadding* self);
VALA_EXTERN void terminal_settings_get_padding (TerminalSettings* self,
                                    TerminalPadding* result);
static gchar* terminal_terminal_process_completed_notification_id (TerminalTerminal* self);
VALA_EXTERN guint terminal_window_get_id (TerminalWindow* self);
VALA_EXTERN guint terminal_terminal_get_id (TerminalTerminal* self);
static void terminal_terminal_on_attention_received (TerminalTerminal* self);
VALA_EXTERN void terminal_terminal_set_needs_attention (TerminalTerminal* self,
                                            gboolean value);
static void terminal_terminal_withdraw_command_completed_notification (TerminalTerminal* self);
static gboolean terminal_terminal_on_key_pressed (TerminalTerminal* self,
                                           guint keyval,
                                           guint keycode,
                                           GdkModifierType state);
static gboolean _terminal_terminal_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                 guint keyval,
                                                                                 guint keycode,
                                                                                 GdkModifierType state,
                                                                                 gpointer self);
static void __lambda11_ (TerminalTerminal* self,
                  GtkGestureClick* gesture,
                  gint n_clicked,
                  gdouble x,
                  gdouble y);
static void ___lambda11__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                             gint n_press,
                                             gdouble x,
                                             gdouble y,
                                             gpointer self);
static void __lambda12_ (TerminalTerminal* self);
static void ___lambda12__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda13_ (TerminalTerminal* self);
static void ___lambda13__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda14_ (TerminalTerminal* self);
static void ___lambda15_ (TerminalTerminal* self);
static void ____lambda15__gsource_once_func (gpointer self);
static void ___lambda14__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void _g_free0_ (gpointer var);
static void _vala_gchar_free_function_content_of (gpointer data);
VALA_EXTERN gboolean terminal_settings_get_use_custom_command (TerminalSettings* self);
VALA_EXTERN const gchar* terminal_settings_get_custom_shell_command (TerminalSettings* self);
VALA_EXTERN gboolean terminal_settings_get_command_as_login_shell (TerminalSettings* self);
static void _terminal_terminal_on_spawn_finished (TerminalTerminal* self,
                                           VteTerminal* t,
                                           GPid pid,
                                           GError* _error_);
static void __terminal_terminal_on_spawn_finished_vte_terminal_spawn_async_callback (VteTerminal* terminal,
                                                                              GPid pid,
                                                                              GError* _error_,
                                                                              gpointer self);
VALA_EXTERN void terminal_terminal_set_pid (TerminalTerminal* self,
                                GPid value);
static void terminal_terminal_on_spawn_finished (TerminalTerminal* self);
VALA_EXTERN GPid terminal_terminal_get_pid (TerminalTerminal* self);
VALA_EXTERN TerminalProcess* terminal_process_new (void);
VALA_EXTERN TerminalProcess* terminal_process_construct (GType object_type);
VALA_EXTERN void terminal_process_set_terminal_fd (TerminalProcess* self,
                                       gint value);
VALA_EXTERN void terminal_process_set_pid (TerminalProcess* self,
                               GPid value);
VALA_EXTERN void terminal_process_set_foreground_pid (TerminalProcess* self,
                                          GPid value);
VALA_EXTERN void terminal_terminal_set_process (TerminalTerminal* self,
                                    TerminalProcess* value);
VALA_EXTERN TerminalProcess* terminal_terminal_get_process (TerminalTerminal* self);
static void __lambda16_ (TerminalTerminal* self,
                  TerminalProcess* _process);
VALA_EXTERN const gchar* terminal_process_get_last_foreground_task_command (TerminalProcess* self);
static void terminal_terminal_send_command_completed_notification (TerminalTerminal* self);
static void ___lambda16__terminal_process_foreground_task_finished (TerminalProcess* _sender,
                                                             gpointer self);
static void __lambda17_ (TerminalTerminal* self,
                  GObject* __process,
                  GParamSpec* spec);
VALA_EXTERN GType terminal_process_context_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TerminalProcessContext terminal_process_get_context (TerminalProcess* self);
static TerminalProcessContext* _terminal_process_context_dup (TerminalProcessContext* self);
static void ___lambda17__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
VALA_EXTERN GType terminal_process_watcher_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalProcessWatcher, g_object_unref)
VALA_EXTERN TerminalProcessWatcher* terminal_process_watcher_get_instance (void);
VALA_EXTERN gboolean terminal_process_watcher_watch (TerminalProcessWatcher* self,
                                         TerminalProcess* process);
static void terminal_terminal_spawn_on_flatpak_data_free (gpointer _data);
static void terminal_terminal_spawn_on_flatpak (TerminalTerminal* self,
                                         VtePtyFlags flags,
                                         const gchar* cwd,
                                         GArray* argv,
                                         GArray* envv,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static gboolean terminal_terminal_spawn_on_flatpak_finish (TerminalTerminal* self,
                                                    GAsyncResult* _res_,
                                                    GPid* p,
                                                    GError** error);
static gboolean terminal_terminal_spawn_on_flatpak_co (TerminalTerminalSpawnOnFlatpakData* _data_);
static void _vala_array_add3 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
static void _vala_array_add4 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
static void _vala_array_add5 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
VALA_EXTERN void terminal_send_host_command (const gchar* cwd,
                                 GArray* argv,
                                 GArray* envv,
                                 gint* fds,
                                 gint fds_length1,
                                 TerminalHostCommandExitedCallback callback,
                                 gpointer callback_target,
                                 GCancellable* cancellable,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
VALA_EXTERN gboolean terminal_send_host_command_finish (GAsyncResult* _res_,
                                            gint* pid,
                                            GError** error);
static void terminal_terminal_on_host_command_exited (TerminalTerminal* self,
                                               guint _pid,
                                               guint status);
static void _terminal_terminal_on_host_command_exited_terminal_host_command_exited_callback (guint pid,
                                                                                      guint status,
                                                                                      gpointer self);
static void terminal_terminal_spawn_on_flatpak_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
VALA_EXTERN gboolean terminal_settings_get_notify_process_completion (TerminalSettings* self);
VALA_EXTERN gboolean terminal_settings_get_easy_copy_paste (TerminalSettings* self);
VALA_EXTERN void terminal_terminal_do_copy_clipboard (TerminalTerminal* self);
VALA_EXTERN void terminal_terminal_do_paste_clipboard (TerminalTerminal* self);
static void terminal_terminal_get_can_close_data_free (gpointer _data);
VALA_EXTERN void terminal_terminal_get_can_close (TerminalTerminal* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
VALA_EXTERN gboolean terminal_terminal_get_can_close_finish (TerminalTerminal* self,
                                                 GAsyncResult* _res_,
                                                 gchar** command);
static gboolean terminal_terminal_get_can_close_co (TerminalTerminalGetCanCloseData* _data_);
VALA_EXTERN void terminal_get_foreground_process (gint terminal_fd,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
VALA_EXTERN gint terminal_get_foreground_process_finish (GAsyncResult* _res_);
static void terminal_terminal_get_can_close_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
VALA_EXTERN gchar* terminal_get_process_cmdline (gint pid);
VALA_EXTERN void terminal_terminal_zoom_in (TerminalTerminal* self);
VALA_EXTERN void terminal_terminal_zoom_out (TerminalTerminal* self);
VALA_EXTERN void terminal_terminal_zoom_default (TerminalTerminal* self);
static void terminal_terminal_do_paste_from_selection_clipboard_data_free (gpointer _data);
VALA_EXTERN void terminal_terminal_do_paste_from_selection_clipboard (TerminalTerminal* self,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
VALA_EXTERN void terminal_terminal_do_paste_from_selection_clipboard_finish (TerminalTerminal* self,
                                                                 GAsyncResult* _res_);
static gboolean terminal_terminal_do_paste_from_selection_clipboard_co (TerminalTerminalDoPasteFromSelectionClipboardData* _data_);
static void terminal_terminal_do_paste_from_selection_clipboard_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_);
VALA_EXTERN gchar* terminal_terminal_get_current_working_directory (TerminalTerminal* self);
VALA_EXTERN gchar* terminal_terminal_get_current_working_directory_for_new_session (TerminalTerminal* previous_terminal);
VALA_EXTERN guint terminal_settings_get_working_directory_mode (TerminalSettings* self);
VALA_EXTERN const gchar* terminal_settings_get_custom_working_directory (TerminalSettings* self);
VALA_EXTERN GType terminal_working_directory_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void terminal_terminal_on_before_close (TerminalTerminal* self);
VALA_EXTERN TerminalScheme* terminal_terminal_get_scheme (TerminalTerminal* self);
VALA_EXTERN void terminal_terminal_set_scheme (TerminalTerminal* self,
                                   TerminalScheme* value);
VALA_EXTERN gboolean terminal_terminal_get_needs_attention (TerminalTerminal* self);
VALA_EXTERN guint terminal_terminal_get_user_scrollback_lines (TerminalTerminal* self);
VALA_EXTERN guint terminal_settings_get_scrollback_mode (TerminalSettings* self);
VALA_EXTERN GType terminal_scrollback_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint terminal_settings_get_scrollback_lines (TerminalSettings* self);
static void terminal_terminal_finalize (GObject * obj);
static GType terminal_terminal_get_type_once (void);
static void _vala_terminal_terminal_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_terminal_terminal_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

VALA_EXTERN const gchar* TERMINAL_CONSTANTS_URL_REGEX_STRINGS[5];

static inline gpointer
terminal_terminal_get_instance_private (TerminalTerminal* self)
{
	return G_STRUCT_MEMBER_P (self, TerminalTerminal_private_offset);
}

/**
   * List of available drop targets for Terminal
   */
static GType
terminal_terminal_drop_targets_get_type_once (void)
{
	static const GEnumValue values[] = {{TERMINAL_TERMINAL_DROP_TARGETS_URILIST, "TERMINAL_TERMINAL_DROP_TARGETS_URILIST", "urilist"}, {TERMINAL_TERMINAL_DROP_TARGETS_STRING, "TERMINAL_TERMINAL_DROP_TARGETS_STRING", "string"}, {TERMINAL_TERMINAL_DROP_TARGETS_TEXT, "TERMINAL_TERMINAL_DROP_TARGETS_TEXT", "text"}, {0, NULL, NULL}};
	GType terminal_terminal_drop_targets_type_id;
	terminal_terminal_drop_targets_type_id = g_enum_register_static ("TerminalTerminalDropTargets", values);
	return terminal_terminal_drop_targets_type_id;
}

static GType
terminal_terminal_drop_targets_get_type (void)
{
	static volatile gsize terminal_terminal_drop_targets_type_id__once = 0;
	if (g_once_init_enter (&terminal_terminal_drop_targets_type_id__once)) {
		GType terminal_terminal_drop_targets_type_id;
		terminal_terminal_drop_targets_type_id = terminal_terminal_drop_targets_get_type_once ();
		g_once_init_leave (&terminal_terminal_drop_targets_type_id__once, terminal_terminal_drop_targets_type_id);
	}
	return terminal_terminal_drop_targets_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 104 "../src/widgets/Terminal.vala"
	return self ? g_object_ref (self) : NULL;
#line 666 "Terminal.c"
}

static void
_terminal_terminal_on_child_exited_vte_terminal_child_exited (VteTerminal* _sender,
                                                              gint status,
                                                              gpointer self)
{
#line 111 "../src/widgets/Terminal.vala"
	terminal_terminal_on_child_exited ((TerminalTerminal*) self, status);
#line 676 "Terminal.c"
}

static void
_terminal_terminal_on_theme_changed_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 114 "../src/widgets/Terminal.vala"
	terminal_terminal_on_theme_changed ((TerminalTerminal*) self);
#line 686 "Terminal.c"
}

static void
_terminal_terminal_on_font_changed_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 115 "../src/widgets/Terminal.vala"
	terminal_terminal_on_font_changed ((TerminalTerminal*) self);
#line 696 "Terminal.c"
}

static void
_terminal_terminal_on_padding_changed_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
#line 116 "../src/widgets/Terminal.vala"
	terminal_terminal_on_padding_changed ((TerminalTerminal*) self);
#line 706 "Terminal.c"
}

TerminalTerminal*
terminal_terminal_construct (GType object_type,
                             TerminalWindow* window,
                             const gchar* command,
                             const gchar* cwd)
{
	TerminalTerminal * self = NULL;
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	TerminalWindow* _tmp3_;
	TerminalSettings* _tmp4_;
	TerminalThemeProvider* _tmp5_;
	TerminalThemeProvider* _tmp6_;
	TerminalSettings* _tmp7_;
	TerminalSettings* _tmp8_;
	TerminalSettings* _tmp9_;
	GError* _inner_error0_ = NULL;
#line 93 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 94 "../src/widgets/Terminal.vala"
	self = (TerminalTerminal*) g_object_new (object_type, "allow-hyperlink", TRUE, "receives-default", TRUE, "scroll-unit-is-pixels", TRUE, NULL);
#line 99 "../src/widgets/Terminal.vala"
	terminal_terminal_set_id (self, terminal_terminal_next_id);
#line 100 "../src/widgets/Terminal.vala"
	_tmp0_ = terminal_terminal_next_id;
#line 100 "../src/widgets/Terminal.vala"
	terminal_terminal_next_id = _tmp0_ + 1;
#line 102 "../src/widgets/Terminal.vala"
	_tmp1_ = vte_terminal_get_scrollback_lines ((VteTerminal*) self);
#line 102 "../src/widgets/Terminal.vala"
	_tmp2_ = _tmp1_;
#line 102 "../src/widgets/Terminal.vala"
	self->priv->original_scrollback_lines = _tmp2_;
#line 104 "../src/widgets/Terminal.vala"
	_tmp3_ = _g_object_ref0 (window);
#line 104 "../src/widgets/Terminal.vala"
	_g_object_unref0 (self->window);
#line 104 "../src/widgets/Terminal.vala"
	self->window = _tmp3_;
#line 106 "../src/widgets/Terminal.vala"
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
#line 107 "../src/widgets/Terminal.vala"
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 108 "../src/widgets/Terminal.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_FILL);
#line 109 "../src/widgets/Terminal.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_FILL);
#line 111 "../src/widgets/Terminal.vala"
	g_signal_connect_object ((VteTerminal*) self, "child-exited", (GCallback) _terminal_terminal_on_child_exited_vte_terminal_child_exited, self, 0);
#line 113 "../src/widgets/Terminal.vala"
	_tmp4_ = terminal_settings_get_default ();
#line 113 "../src/widgets/Terminal.vala"
	_g_object_unref0 (self->priv->settings);
#line 113 "../src/widgets/Terminal.vala"
	self->priv->settings = _tmp4_;
#line 114 "../src/widgets/Terminal.vala"
	_tmp5_ = terminal_theme_provider_get_default ();
#line 114 "../src/widgets/Terminal.vala"
	_tmp6_ = _tmp5_;
#line 114 "../src/widgets/Terminal.vala"
	g_signal_connect_object ((GObject*) _tmp6_, "notify::current-theme", (GCallback) _terminal_terminal_on_theme_changed_g_object_notify, self, 0);
#line 114 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_tmp6_);
#line 115 "../src/widgets/Terminal.vala"
	_tmp7_ = self->priv->settings;
#line 115 "../src/widgets/Terminal.vala"
	g_signal_connect_object ((GObject*) _tmp7_, "notify::font", (GCallback) _terminal_terminal_on_font_changed_g_object_notify, self, 0);
#line 116 "../src/widgets/Terminal.vala"
	_tmp8_ = self->priv->settings;
#line 116 "../src/widgets/Terminal.vala"
	g_signal_connect_object ((GObject*) _tmp8_, "notify::terminal-padding", (GCallback) _terminal_terminal_on_padding_changed_g_object_notify, self, 0);
#line 117 "../src/widgets/Terminal.vala"
	_tmp9_ = self->priv->settings;
#line 117 "../src/widgets/Terminal.vala"
	g_signal_connect_object ((GObject*) _tmp9_, "notify::opacity", (GCallback) _terminal_terminal_on_theme_changed_g_object_notify, self, 0);
#line 119 "../src/widgets/Terminal.vala"
	terminal_terminal_setup_drag_drop (self);
#line 120 "../src/widgets/Terminal.vala"
	terminal_terminal_setup_regexes (self);
#line 121 "../src/widgets/Terminal.vala"
	terminal_terminal_connect_signals (self);
#line 122 "../src/widgets/Terminal.vala"
	terminal_terminal_bind_data (self);
#line 123 "../src/widgets/Terminal.vala"
	terminal_terminal_on_theme_changed (self);
#line 124 "../src/widgets/Terminal.vala"
	terminal_terminal_on_font_changed (self);
#line 125 "../src/widgets/Terminal.vala"
	terminal_terminal_on_padding_changed (self);
#line 799 "Terminal.c"
	{
#line 128 "../src/widgets/Terminal.vala"
		terminal_terminal_spawn (self, command, cwd, &_inner_error0_);
#line 128 "../src/widgets/Terminal.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 805 "Terminal.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 127 "../src/widgets/Terminal.vala"
		e = _inner_error0_;
#line 127 "../src/widgets/Terminal.vala"
		_inner_error0_ = NULL;
#line 131 "../src/widgets/Terminal.vala"
		_tmp10_ = e;
#line 131 "../src/widgets/Terminal.vala"
		_tmp11_ = _tmp10_->message;
#line 131 "../src/widgets/Terminal.vala"
		g_warning ("Terminal.vala:131: %s", _tmp11_);
#line 127 "../src/widgets/Terminal.vala"
		_g_error_free0 (e);
#line 827 "Terminal.c"
	}
	__finally0:
#line 127 "../src/widgets/Terminal.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 127 "../src/widgets/Terminal.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 127 "../src/widgets/Terminal.vala"
		g_clear_error (&_inner_error0_);
#line 127 "../src/widgets/Terminal.vala"
		return NULL;
#line 838 "Terminal.c"
	}
#line 93 "../src/widgets/Terminal.vala"
	return self;
#line 842 "Terminal.c"
}

TerminalTerminal*
terminal_terminal_new (TerminalWindow* window,
                       const gchar* command,
                       const gchar* cwd)
{
#line 93 "../src/widgets/Terminal.vala"
	return terminal_terminal_construct (TERMINAL_TYPE_TERMINAL, window, command, cwd);
#line 852 "Terminal.c"
}

static void
terminal_terminal_real_dispose (GObject* base)
{
	TerminalTerminal * self;
	GCancellable* _tmp0_ = NULL;
	GCancellable* _tmp1_;
#line 141 "../src/widgets/Terminal.vala"
	self = (TerminalTerminal*) base;
#line 145 "../src/widgets/Terminal.vala"
	_tmp1_ = self->priv->fp_spawn_host_command_callback_cancellable;
#line 145 "../src/widgets/Terminal.vala"
	_tmp0_ = _tmp1_;
#line 145 "../src/widgets/Terminal.vala"
	if (_tmp0_ != NULL) {
#line 145 "../src/widgets/Terminal.vala"
		g_cancellable_cancel (_tmp0_);
#line 871 "Terminal.c"
	}
#line 146 "../src/widgets/Terminal.vala"
	G_OBJECT_CLASS (terminal_terminal_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, vte_terminal_get_type (), VteTerminal));
#line 875 "Terminal.c"
}

static gboolean
_terminal_terminal_on_drag_data_received_gtk_drop_target_drop (GtkDropTarget* _sender,
                                                               GValue* value,
                                                               gdouble x,
                                                               gdouble y,
                                                               gpointer self)
{
	gboolean result;
	result = terminal_terminal_on_drag_data_received ((TerminalTerminal*) self, _sender, value, x, y);
#line 160 "../src/widgets/Terminal.vala"
	return result;
#line 889 "Terminal.c"
}

static void
terminal_terminal_setup_drag_drop (TerminalTerminal* self)
{
	GtkDropTarget* target = NULL;
	GtkDropTarget* _tmp0_;
	GType* _tmp1_;
	GType* _tmp2_;
	gint _tmp2__length1;
	GtkEventController* _tmp3_;
#line 151 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 152 "../src/widgets/Terminal.vala"
	_tmp0_ = gtk_drop_target_new (G_TYPE_INVALID, GDK_ACTION_COPY);
#line 152 "../src/widgets/Terminal.vala"
	target = _tmp0_;
#line 154 "../src/widgets/Terminal.vala"
	_tmp1_ = g_new0 (GType, 3);
#line 154 "../src/widgets/Terminal.vala"
	_tmp1_[0] = gdk_file_list_get_type ();
#line 154 "../src/widgets/Terminal.vala"
	_tmp1_[1] = g_file_get_type ();
#line 154 "../src/widgets/Terminal.vala"
	_tmp1_[2] = G_TYPE_STRING;
#line 154 "../src/widgets/Terminal.vala"
	_tmp2_ = _tmp1_;
#line 154 "../src/widgets/Terminal.vala"
	_tmp2__length1 = 3;
#line 154 "../src/widgets/Terminal.vala"
	gtk_drop_target_set_gtypes (target, _tmp2_, (gsize) 3);
#line 154 "../src/widgets/Terminal.vala"
	_tmp2_ = (g_free (_tmp2_), NULL);
#line 160 "../src/widgets/Terminal.vala"
	g_signal_connect_object (target, "drop", (GCallback) _terminal_terminal_on_drag_data_received_gtk_drop_target_drop, self, 0);
#line 162 "../src/widgets/Terminal.vala"
	_tmp3_ = _g_object_ref0 ((GtkEventController*) target);
#line 162 "../src/widgets/Terminal.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp3_);
#line 151 "../src/widgets/Terminal.vala"
	_g_object_unref0 (target);
#line 931 "Terminal.c"
}

static GdkFileList*
_vala_GdkFileList_copy (GdkFileList* self)
{
#line 174 "../src/widgets/Terminal.vala"
	return g_boxed_copy (gdk_file_list_get_type (), self);
#line 939 "Terminal.c"
}

static gpointer
__vala_GdkFileList_copy0 (gpointer self)
{
#line 174 "../src/widgets/Terminal.vala"
	return self ? _vala_GdkFileList_copy (self) : NULL;
#line 947 "Terminal.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 984 "Terminal.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 990 "Terminal.c"
}

static void
_vala_GdkFileList_free (GdkFileList* self)
{
#line 181 "../src/widgets/Terminal.vala"
	g_boxed_free (gdk_file_list_get_type (), self);
#line 998 "Terminal.c"
}

static gboolean
terminal_terminal_on_drag_data_received (TerminalTerminal* self,
                                         GtkDropTarget* target,
                                         GValue* value,
                                         gdouble x,
                                         gdouble y)
{
	GType vtype = 0UL;
	gboolean result;
#line 165 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 165 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (target != NULL, FALSE);
#line 165 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 171 "../src/widgets/Terminal.vala"
	vtype = G_VALUE_TYPE (value);
#line 173 "../src/widgets/Terminal.vala"
	if (vtype == gdk_file_list_get_type ()) {
#line 1020 "Terminal.c"
		GdkFileList* list = NULL;
		void* _tmp0_;
		GdkFileList* _tmp1_;
		GdkFileList* _tmp2_;
		GSList* _tmp3_;
#line 174 "../src/widgets/Terminal.vala"
		_tmp0_ = g_value_get_boxed (value);
#line 174 "../src/widgets/Terminal.vala"
		_tmp1_ = __vala_GdkFileList_copy0 ((GdkFileList*) _tmp0_);
#line 174 "../src/widgets/Terminal.vala"
		list = _tmp1_;
#line 176 "../src/widgets/Terminal.vala"
		_tmp2_ = list;
#line 176 "../src/widgets/Terminal.vala"
		_tmp3_ = gdk_file_list_get_files (_tmp2_);
#line 1036 "Terminal.c"
		{
			GSList* file_collection = NULL;
			GSList* file_it = NULL;
#line 176 "../src/widgets/Terminal.vala"
			file_collection = _tmp3_;
#line 176 "../src/widgets/Terminal.vala"
			for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 1044 "Terminal.c"
				GFile* file = NULL;
#line 176 "../src/widgets/Terminal.vala"
				file = (GFile*) file_it->data;
#line 1048 "Terminal.c"
				{
					GFile* _tmp4_;
					gchar* _tmp5_;
					gchar* _tmp6_;
					gchar* _tmp7_;
					gchar* _tmp8_;
					guint8* _tmp9_;
					gint _tmp9__length1;
					gint _tmp10_ = 0;
					guint8* _tmp11_;
					gint _tmp11__length1;
					guint8* _tmp12_;
					gint _tmp12__length1;
					gint _tmp13_ = 0;
					guint8* _tmp14_;
					gint _tmp14__length1;
#line 177 "../src/widgets/Terminal.vala"
					_tmp4_ = file;
#line 177 "../src/widgets/Terminal.vala"
					_tmp5_ = g_file_get_path (_tmp4_);
#line 177 "../src/widgets/Terminal.vala"
					_tmp6_ = _tmp5_;
#line 177 "../src/widgets/Terminal.vala"
					_tmp7_ = g_shell_quote (_tmp6_);
#line 177 "../src/widgets/Terminal.vala"
					_tmp8_ = _tmp7_;
#line 177 "../src/widgets/Terminal.vala"
					_tmp9_ = string_get_data (_tmp8_, &_tmp10_);
#line 177 "../src/widgets/Terminal.vala"
					_tmp9__length1 = _tmp10_;
#line 177 "../src/widgets/Terminal.vala"
					_tmp11_ = _tmp9_;
#line 177 "../src/widgets/Terminal.vala"
					_tmp11__length1 = _tmp9__length1;
#line 177 "../src/widgets/Terminal.vala"
					vte_terminal_feed_child ((VteTerminal*) self, _tmp11_, (gssize) _tmp11__length1);
#line 177 "../src/widgets/Terminal.vala"
					_g_free0 (_tmp8_);
#line 177 "../src/widgets/Terminal.vala"
					_g_free0 (_tmp6_);
#line 178 "../src/widgets/Terminal.vala"
					_tmp12_ = string_get_data (" ", &_tmp13_);
#line 178 "../src/widgets/Terminal.vala"
					_tmp12__length1 = _tmp13_;
#line 178 "../src/widgets/Terminal.vala"
					_tmp14_ = _tmp12_;
#line 178 "../src/widgets/Terminal.vala"
					_tmp14__length1 = _tmp12__length1;
#line 178 "../src/widgets/Terminal.vala"
					vte_terminal_feed_child ((VteTerminal*) self, _tmp14_, (gssize) _tmp14__length1);
#line 1099 "Terminal.c"
				}
			}
#line 176 "../src/widgets/Terminal.vala"
			(file_collection == NULL) ? NULL : (file_collection = (g_slist_free (file_collection), NULL));
#line 1104 "Terminal.c"
		}
#line 181 "../src/widgets/Terminal.vala"
		result = TRUE;
#line 181 "../src/widgets/Terminal.vala"
		__vala_GdkFileList_free0 (list);
#line 181 "../src/widgets/Terminal.vala"
		return result;
#line 1112 "Terminal.c"
	} else {
#line 183 "../src/widgets/Terminal.vala"
		if (vtype == g_file_get_type ()) {
#line 1116 "Terminal.c"
			GFile* file = NULL;
			GObject* _tmp15_;
			GFile* _tmp16_;
			GFile* _tmp17_ = NULL;
			GFile* _tmp18_;
			gchar* _tmp19_ = NULL;
			gchar* path = NULL;
			gchar* _tmp21_;
			const gchar* _tmp22_;
#line 184 "../src/widgets/Terminal.vala"
			_tmp15_ = g_value_get_object (value);
#line 184 "../src/widgets/Terminal.vala"
			_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, g_file_get_type (), GFile));
#line 184 "../src/widgets/Terminal.vala"
			file = _tmp16_;
#line 185 "../src/widgets/Terminal.vala"
			_tmp18_ = file;
#line 185 "../src/widgets/Terminal.vala"
			_tmp17_ = _tmp18_;
#line 185 "../src/widgets/Terminal.vala"
			_tmp19_ = NULL;
#line 185 "../src/widgets/Terminal.vala"
			if (_tmp17_ != NULL) {
#line 1140 "Terminal.c"
				gchar* _tmp20_;
#line 185 "../src/widgets/Terminal.vala"
				_tmp20_ = g_file_get_path (_tmp17_);
#line 185 "../src/widgets/Terminal.vala"
				_g_free0 (_tmp19_);
#line 185 "../src/widgets/Terminal.vala"
				_tmp19_ = _tmp20_;
#line 1148 "Terminal.c"
			}
#line 185 "../src/widgets/Terminal.vala"
			_tmp21_ = _tmp19_;
#line 185 "../src/widgets/Terminal.vala"
			_tmp19_ = NULL;
#line 185 "../src/widgets/Terminal.vala"
			path = _tmp21_;
#line 187 "../src/widgets/Terminal.vala"
			_tmp22_ = path;
#line 187 "../src/widgets/Terminal.vala"
			if (_tmp22_ != NULL) {
#line 1160 "Terminal.c"
				const gchar* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
				guint8* _tmp26_;
				gint _tmp26__length1;
				gint _tmp27_ = 0;
				guint8* _tmp28_;
				gint _tmp28__length1;
				guint8* _tmp29_;
				gint _tmp29__length1;
				gint _tmp30_ = 0;
				guint8* _tmp31_;
				gint _tmp31__length1;
#line 188 "../src/widgets/Terminal.vala"
				_tmp23_ = path;
#line 188 "../src/widgets/Terminal.vala"
				_tmp24_ = g_shell_quote (_tmp23_);
#line 188 "../src/widgets/Terminal.vala"
				_tmp25_ = _tmp24_;
#line 188 "../src/widgets/Terminal.vala"
				_tmp26_ = string_get_data (_tmp25_, &_tmp27_);
#line 188 "../src/widgets/Terminal.vala"
				_tmp26__length1 = _tmp27_;
#line 188 "../src/widgets/Terminal.vala"
				_tmp28_ = _tmp26_;
#line 188 "../src/widgets/Terminal.vala"
				_tmp28__length1 = _tmp26__length1;
#line 188 "../src/widgets/Terminal.vala"
				vte_terminal_feed_child ((VteTerminal*) self, _tmp28_, (gssize) _tmp28__length1);
#line 188 "../src/widgets/Terminal.vala"
				_g_free0 (_tmp25_);
#line 189 "../src/widgets/Terminal.vala"
				_tmp29_ = string_get_data (" ", &_tmp30_);
#line 189 "../src/widgets/Terminal.vala"
				_tmp29__length1 = _tmp30_;
#line 189 "../src/widgets/Terminal.vala"
				_tmp31_ = _tmp29_;
#line 189 "../src/widgets/Terminal.vala"
				_tmp31__length1 = _tmp29__length1;
#line 189 "../src/widgets/Terminal.vala"
				vte_terminal_feed_child ((VteTerminal*) self, _tmp31_, (gssize) _tmp31__length1);
#line 1202 "Terminal.c"
			}
#line 192 "../src/widgets/Terminal.vala"
			result = TRUE;
#line 192 "../src/widgets/Terminal.vala"
			_g_free0 (path);
#line 192 "../src/widgets/Terminal.vala"
			_g_free0 (_tmp19_);
#line 192 "../src/widgets/Terminal.vala"
			_g_object_unref0 (file);
#line 192 "../src/widgets/Terminal.vala"
			return result;
#line 1214 "Terminal.c"
		} else {
#line 194 "../src/widgets/Terminal.vala"
			if (vtype == G_TYPE_STRING) {
#line 1218 "Terminal.c"
				gchar* text = NULL;
				const gchar* _tmp32_;
				gchar* _tmp33_;
				const gchar* _tmp34_;
#line 195 "../src/widgets/Terminal.vala"
				_tmp32_ = g_value_get_string (value);
#line 195 "../src/widgets/Terminal.vala"
				_tmp33_ = g_strdup (_tmp32_);
#line 195 "../src/widgets/Terminal.vala"
				text = _tmp33_;
#line 197 "../src/widgets/Terminal.vala"
				_tmp34_ = text;
#line 197 "../src/widgets/Terminal.vala"
				if (_tmp34_ != NULL) {
#line 1233 "Terminal.c"
					const gchar* _tmp35_;
					guint8* _tmp36_;
					gint _tmp36__length1;
					gint _tmp37_ = 0;
					guint8* _tmp38_;
					gint _tmp38__length1;
#line 198 "../src/widgets/Terminal.vala"
					_tmp35_ = text;
#line 198 "../src/widgets/Terminal.vala"
					_tmp36_ = string_get_data (_tmp35_, &_tmp37_);
#line 198 "../src/widgets/Terminal.vala"
					_tmp36__length1 = _tmp37_;
#line 198 "../src/widgets/Terminal.vala"
					_tmp38_ = _tmp36_;
#line 198 "../src/widgets/Terminal.vala"
					_tmp38__length1 = _tmp36__length1;
#line 198 "../src/widgets/Terminal.vala"
					vte_terminal_feed_child ((VteTerminal*) self, _tmp38_, (gssize) _tmp38__length1);
#line 1252 "Terminal.c"
				}
#line 201 "../src/widgets/Terminal.vala"
				result = TRUE;
#line 201 "../src/widgets/Terminal.vala"
				_g_free0 (text);
#line 201 "../src/widgets/Terminal.vala"
				return result;
#line 1260 "Terminal.c"
			}
		}
	}
#line 204 "../src/widgets/Terminal.vala"
	g_warning ("Terminal.vala:204: You dropped something Terminal can't handle yet :(");
#line 205 "../src/widgets/Terminal.vala"
	result = FALSE;
#line 205 "../src/widgets/Terminal.vala"
	return result;
#line 1270 "Terminal.c"
}

static void
terminal_terminal_setup_regexes (TerminalTerminal* self)
{
	GError* _inner_error0_ = NULL;
#line 208 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 1279 "Terminal.c"
	{
		const gchar** str_collection = NULL;
		gint str_collection_length1 = 0;
		gint _str_collection_size_ = 0;
		gint str_it = 0;
#line 209 "../src/widgets/Terminal.vala"
		str_collection = TERMINAL_CONSTANTS_URL_REGEX_STRINGS;
#line 209 "../src/widgets/Terminal.vala"
		str_collection_length1 = G_N_ELEMENTS (TERMINAL_CONSTANTS_URL_REGEX_STRINGS);
#line 209 "../src/widgets/Terminal.vala"
		for (str_it = 0; str_it < str_collection_length1; str_it = str_it + 1) {
#line 1291 "Terminal.c"
			const gchar* str = NULL;
#line 209 "../src/widgets/Terminal.vala"
			str = str_collection[str_it];
#line 1295 "Terminal.c"
			{
				{
					VteRegex* reg = NULL;
					const gchar* _tmp0_;
					VteRegex* _tmp1_;
					gint id = 0;
					VteRegex* _tmp2_;
#line 211 "../src/widgets/Terminal.vala"
					_tmp0_ = str;
#line 211 "../src/widgets/Terminal.vala"
					_tmp1_ = vte_regex_new_for_match (_tmp0_, (gssize) -1, (guint32) PCRE2_MULTILINE, &_inner_error0_);
#line 211 "../src/widgets/Terminal.vala"
					reg = _tmp1_;
#line 211 "../src/widgets/Terminal.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1311 "Terminal.c"
						goto __catch0_g_error;
					}
#line 214 "../src/widgets/Terminal.vala"
					_tmp2_ = reg;
#line 214 "../src/widgets/Terminal.vala"
					id = vte_terminal_match_add_regex ((VteTerminal*) self, _tmp2_, (guint32) 0);
#line 215 "../src/widgets/Terminal.vala"
					vte_terminal_match_set_cursor_name ((VteTerminal*) self, id, "pointer");
#line 210 "../src/widgets/Terminal.vala"
					_vte_regex_unref0 (reg);
#line 1322 "Terminal.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp3_;
					const gchar* _tmp4_;
#line 210 "../src/widgets/Terminal.vala"
					e = _inner_error0_;
#line 210 "../src/widgets/Terminal.vala"
					_inner_error0_ = NULL;
#line 218 "../src/widgets/Terminal.vala"
					_tmp3_ = e;
#line 218 "../src/widgets/Terminal.vala"
					_tmp4_ = _tmp3_->message;
#line 218 "../src/widgets/Terminal.vala"
					g_warning ("Terminal.vala:218: %s", _tmp4_);
#line 210 "../src/widgets/Terminal.vala"
					_g_error_free0 (e);
#line 1342 "Terminal.c"
				}
				__finally0:
#line 210 "../src/widgets/Terminal.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 210 "../src/widgets/Terminal.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 210 "../src/widgets/Terminal.vala"
					g_clear_error (&_inner_error0_);
#line 210 "../src/widgets/Terminal.vala"
					return;
#line 1353 "Terminal.c"
				}
			}
		}
	}
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 224 "../src/widgets/Terminal.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 1365 "Terminal.c"
}

static void
terminal_terminal_on_font_changed (TerminalTerminal* self)
{
	TerminalSettings* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	PangoFontDescription* _tmp3_;
	PangoFontDescription* _tmp4_;
#line 223 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 224 "../src/widgets/Terminal.vala"
	_tmp0_ = self->priv->settings;
#line 224 "../src/widgets/Terminal.vala"
	_tmp1_ = terminal_settings_get_font (_tmp0_);
#line 224 "../src/widgets/Terminal.vala"
	_tmp2_ = _tmp1_;
#line 224 "../src/widgets/Terminal.vala"
	_tmp3_ = pango_font_description_from_string (_tmp2_);
#line 224 "../src/widgets/Terminal.vala"
	_tmp4_ = _tmp3_;
#line 224 "../src/widgets/Terminal.vala"
	g_object_set ((VteTerminal*) self, "font-desc", _tmp4_, NULL);
#line 224 "../src/widgets/Terminal.vala"
	__vala_PangoFontDescription_free0 (_tmp4_);
#line 1392 "Terminal.c"
}

static void
_vala_GdkRGBA_free (GdkRGBA* self)
{
#line 232 "../src/widgets/Terminal.vala"
	g_boxed_free (gdk_rgba_get_type (), self);
#line 1400 "Terminal.c"
}

static void
terminal_terminal_get_background_color (TerminalTerminal* self,
                                        TerminalScheme* theme,
                                        GdkRGBA* result)
{
	GdkRGBA* bg_transparent = NULL;
	GdkRGBA* _tmp0_;
	GdkRGBA* _tmp1_;
	GdkRGBA* _tmp2_;
	TerminalSettings* _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	GdkRGBA* _tmp6_;
	GdkRGBA _tmp7_;
#line 229 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 229 "../src/widgets/Terminal.vala"
	g_return_if_fail (theme != NULL);
#line 230 "../src/widgets/Terminal.vala"
	_tmp0_ = terminal_scheme_get_background_color (theme);
#line 230 "../src/widgets/Terminal.vala"
	_tmp1_ = _tmp0_;
#line 230 "../src/widgets/Terminal.vala"
	_tmp2_ = gdk_rgba_copy (_tmp1_);
#line 230 "../src/widgets/Terminal.vala"
	bg_transparent = _tmp2_;
#line 231 "../src/widgets/Terminal.vala"
	_tmp3_ = self->priv->settings;
#line 231 "../src/widgets/Terminal.vala"
	_tmp4_ = terminal_settings_get_opacity (_tmp3_);
#line 231 "../src/widgets/Terminal.vala"
	_tmp5_ = _tmp4_;
#line 231 "../src/widgets/Terminal.vala"
	(*bg_transparent).alpha = _tmp5_ * 0.01f;
#line 232 "../src/widgets/Terminal.vala"
	_tmp6_ = bg_transparent;
#line 232 "../src/widgets/Terminal.vala"
	_tmp7_ = *_tmp6_;
#line 232 "../src/widgets/Terminal.vala"
	__vala_GdkRGBA_free0 (_tmp6_);
#line 232 "../src/widgets/Terminal.vala"
	*result = _tmp7_;
#line 232 "../src/widgets/Terminal.vala"
	return;
#line 1447 "Terminal.c"
}

static void
terminal_terminal_on_theme_changed (TerminalTerminal* self)
{
	TerminalThemeProvider* theme_provider = NULL;
	TerminalThemeProvider* _tmp0_;
	gchar* theme_name = NULL;
	TerminalThemeProvider* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	TerminalScheme* theme = NULL;
	TerminalThemeProvider* _tmp5_;
	GHashTable* _tmp6_;
	const gchar* _tmp7_;
	gconstpointer _tmp8_;
	TerminalScheme* _tmp9_;
	TerminalScheme* _tmp10_;
	GdkRGBA bg = {0};
	TerminalScheme* _tmp12_;
	GdkRGBA _tmp13_ = {0};
	TerminalScheme* _tmp14_;
	GdkRGBA* _tmp15_;
	GdkRGBA* _tmp16_;
	GdkRGBA _tmp17_;
	TerminalScheme* _tmp18_;
	GArray* _tmp19_;
	GArray* _tmp20_;
	gpointer* _tmp21_;
	gint _tmp21__length1;
#line 235 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 236 "../src/widgets/Terminal.vala"
	_tmp0_ = terminal_theme_provider_get_default ();
#line 236 "../src/widgets/Terminal.vala"
	theme_provider = _tmp0_;
#line 237 "../src/widgets/Terminal.vala"
	_tmp1_ = theme_provider;
#line 237 "../src/widgets/Terminal.vala"
	_tmp2_ = terminal_theme_provider_get_current_theme (_tmp1_);
#line 237 "../src/widgets/Terminal.vala"
	_tmp3_ = _tmp2_;
#line 237 "../src/widgets/Terminal.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 237 "../src/widgets/Terminal.vala"
	theme_name = _tmp4_;
#line 238 "../src/widgets/Terminal.vala"
	_tmp5_ = theme_provider;
#line 238 "../src/widgets/Terminal.vala"
	_tmp6_ = _tmp5_->themes;
#line 238 "../src/widgets/Terminal.vala"
	_tmp7_ = theme_name;
#line 238 "../src/widgets/Terminal.vala"
	_tmp8_ = g_hash_table_lookup (_tmp6_, _tmp7_);
#line 238 "../src/widgets/Terminal.vala"
	_tmp9_ = _g_object_ref0 ((TerminalScheme*) _tmp8_);
#line 238 "../src/widgets/Terminal.vala"
	theme = _tmp9_;
#line 240 "../src/widgets/Terminal.vala"
	_tmp10_ = theme;
#line 240 "../src/widgets/Terminal.vala"
	if (_tmp10_ == NULL) {
#line 1511 "Terminal.c"
		const gchar* _tmp11_;
#line 241 "../src/widgets/Terminal.vala"
		_tmp11_ = theme_name;
#line 241 "../src/widgets/Terminal.vala"
		g_warning ("Terminal.vala:241: INVALID THEME '%s'", _tmp11_);
#line 242 "../src/widgets/Terminal.vala"
		_g_object_unref0 (theme);
#line 242 "../src/widgets/Terminal.vala"
		_g_free0 (theme_name);
#line 242 "../src/widgets/Terminal.vala"
		_g_object_unref0 (theme_provider);
#line 242 "../src/widgets/Terminal.vala"
		return;
#line 1525 "Terminal.c"
	}
#line 245 "../src/widgets/Terminal.vala"
	_tmp12_ = theme;
#line 245 "../src/widgets/Terminal.vala"
	terminal_terminal_get_background_color (self, _tmp12_, &_tmp13_);
#line 245 "../src/widgets/Terminal.vala"
	bg = _tmp13_;
#line 246 "../src/widgets/Terminal.vala"
	_tmp14_ = theme;
#line 246 "../src/widgets/Terminal.vala"
	_tmp15_ = terminal_scheme_get_foreground_color (_tmp14_);
#line 246 "../src/widgets/Terminal.vala"
	_tmp16_ = _tmp15_;
#line 246 "../src/widgets/Terminal.vala"
	_tmp17_ = bg;
#line 246 "../src/widgets/Terminal.vala"
	_tmp18_ = theme;
#line 246 "../src/widgets/Terminal.vala"
	_tmp19_ = terminal_scheme_get_palette (_tmp18_);
#line 246 "../src/widgets/Terminal.vala"
	_tmp20_ = _tmp19_;
#line 246 "../src/widgets/Terminal.vala"
	_tmp21_ = _tmp20_->data;
#line 246 "../src/widgets/Terminal.vala"
	_tmp21__length1 = _tmp20_->len;
#line 246 "../src/widgets/Terminal.vala"
	vte_terminal_set_colors ((VteTerminal*) self, _tmp16_, &_tmp17_, _tmp21_, (gsize) _tmp21__length1);
#line 235 "../src/widgets/Terminal.vala"
	_g_object_unref0 (theme);
#line 235 "../src/widgets/Terminal.vala"
	_g_free0 (theme_name);
#line 235 "../src/widgets/Terminal.vala"
	_g_object_unref0 (theme_provider);
#line 1559 "Terminal.c"
}

static void
terminal_terminal_on_padding_changed (TerminalTerminal* self)
{
	TerminalPadding pad = {0};
	TerminalSettings* _tmp0_;
	TerminalPadding _tmp1_ = {0};
	GtkCssProvider* _tmp2_;
	TerminalPadding _tmp5_;
	TerminalPadding _tmp6_;
	TerminalPadding _tmp7_;
	TerminalPadding _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GtkCssProvider* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkCssProvider* _tmp13_;
#line 254 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 255 "../src/widgets/Terminal.vala"
	_tmp0_ = self->priv->settings;
#line 255 "../src/widgets/Terminal.vala"
	terminal_settings_get_padding (_tmp0_, &_tmp1_);
#line 255 "../src/widgets/Terminal.vala"
	pad = _tmp1_;
#line 257 "../src/widgets/Terminal.vala"
	_tmp2_ = self->priv->padding_provider;
#line 257 "../src/widgets/Terminal.vala"
	if (_tmp2_ != NULL) {
#line 1590 "Terminal.c"
		GtkStyleContext* _tmp3_;
		GtkCssProvider* _tmp4_;
#line 258 "../src/widgets/Terminal.vala"
		_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 258 "../src/widgets/Terminal.vala"
		_tmp4_ = self->priv->padding_provider;
#line 258 "../src/widgets/Terminal.vala"
		gtk_style_context_remove_provider (_tmp3_, (GtkStyleProvider*) _tmp4_);
#line 259 "../src/widgets/Terminal.vala"
		_g_object_unref0 (self->priv->padding_provider);
#line 259 "../src/widgets/Terminal.vala"
		self->priv->padding_provider = NULL;
#line 1603 "Terminal.c"
	}
#line 262 "../src/widgets/Terminal.vala"
	_tmp5_ = pad;
#line 262 "../src/widgets/Terminal.vala"
	_tmp6_ = pad;
#line 262 "../src/widgets/Terminal.vala"
	_tmp7_ = pad;
#line 262 "../src/widgets/Terminal.vala"
	_tmp8_ = pad;
#line 262 "../src/widgets/Terminal.vala"
	_tmp9_ = g_strdup_printf ("vte-terminal { padding: %upx %upx %upx %upx; }", _tmp5_.top, _tmp6_.right, _tmp7_.bottom, _tmp8_.left);
#line 262 "../src/widgets/Terminal.vala"
	_tmp10_ = _tmp9_;
#line 262 "../src/widgets/Terminal.vala"
	_tmp11_ = pq_marble_get_css_provider_for_data (_tmp10_);
#line 262 "../src/widgets/Terminal.vala"
	_g_object_unref0 (self->priv->padding_provider);
#line 262 "../src/widgets/Terminal.vala"
	self->priv->padding_provider = _tmp11_;
#line 262 "../src/widgets/Terminal.vala"
	_g_free0 (_tmp10_);
#line 271 "../src/widgets/Terminal.vala"
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 271 "../src/widgets/Terminal.vala"
	_tmp13_ = self->priv->padding_provider;
#line 271 "../src/widgets/Terminal.vala"
	gtk_style_context_add_provider (_tmp12_, (GtkStyleProvider*) _tmp13_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 1631 "Terminal.c"
}

static void
terminal_terminal_bind_data (TerminalTerminal* self)
{
	TerminalSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	TerminalSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	TerminalSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	TerminalSettings* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	TerminalSettings* _tmp12_;
	TerminalSettings* _tmp13_;
	TerminalSettings* _tmp14_;
#line 277 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 278 "../src/widgets/Terminal.vala"
	_tmp0_ = self->priv->settings;
#line 278 "../src/widgets/Terminal.vala"
	_tmp1_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp0_);
#line 278 "../src/widgets/Terminal.vala"
	_tmp2_ = _tmp1_;
#line 278 "../src/widgets/Terminal.vala"
	g_settings_bind (_tmp2_, "theme-bold-is-bright", (GObject*) self, "bold-is-bright", G_SETTINGS_BIND_DEFAULT);
#line 285 "../src/widgets/Terminal.vala"
	_tmp3_ = self->priv->settings;
#line 285 "../src/widgets/Terminal.vala"
	_tmp4_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp3_);
#line 285 "../src/widgets/Terminal.vala"
	_tmp5_ = _tmp4_;
#line 285 "../src/widgets/Terminal.vala"
	g_settings_bind (_tmp5_, "terminal-bell", (GObject*) self, "audible-bell", G_SETTINGS_BIND_DEFAULT);
#line 292 "../src/widgets/Terminal.vala"
	_tmp6_ = self->priv->settings;
#line 292 "../src/widgets/Terminal.vala"
	_tmp7_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp6_);
#line 292 "../src/widgets/Terminal.vala"
	_tmp8_ = _tmp7_;
#line 292 "../src/widgets/Terminal.vala"
	g_settings_bind (_tmp8_, "terminal-cell-width", (GObject*) self, "cell-width-scale", G_SETTINGS_BIND_DEFAULT);
#line 299 "../src/widgets/Terminal.vala"
	_tmp9_ = self->priv->settings;
#line 299 "../src/widgets/Terminal.vala"
	_tmp10_ = pq_marble_settings_get_schema ((PQMarbleSettings*) _tmp9_);
#line 299 "../src/widgets/Terminal.vala"
	_tmp11_ = _tmp10_;
#line 299 "../src/widgets/Terminal.vala"
	g_settings_bind (_tmp11_, "terminal-cell-height", (GObject*) self, "cell-height-scale", G_SETTINGS_BIND_DEFAULT);
#line 306 "../src/widgets/Terminal.vala"
	_tmp12_ = self->priv->settings;
#line 306 "../src/widgets/Terminal.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp12_, "cursor-shape", (GObject*) self, "cursor-shape", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 315 "../src/widgets/Terminal.vala"
	_tmp13_ = self->priv->settings;
#line 315 "../src/widgets/Terminal.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp13_, "cursor-blink-mode", (GObject*) self, "cursor-blink-mode", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 324 "../src/widgets/Terminal.vala"
	g_object_bind_property_with_closures ((GObject*) self, "user-scrollback-lines", (GObject*) self, "scrollback-lines", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 341 "../src/widgets/Terminal.vala"
	_tmp14_ = self->priv->settings;
#line 341 "../src/widgets/Terminal.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp14_, "show-scrollbars", (GObject*) self, "enable-fallback-scrolling", G_BINDING_SYNC_CREATE | G_BINDING_INVERT_BOOLEAN, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 1700 "Terminal.c"
}

static gchar*
terminal_terminal_process_completed_notification_id (TerminalTerminal* self)
{
	TerminalWindow* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 351 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 352 "../src/widgets/Terminal.vala"
	_tmp0_ = self->window;
#line 352 "../src/widgets/Terminal.vala"
	_tmp1_ = terminal_window_get_id (_tmp0_);
#line 352 "../src/widgets/Terminal.vala"
	_tmp2_ = _tmp1_;
#line 352 "../src/widgets/Terminal.vala"
	_tmp3_ = self->priv->_id;
#line 352 "../src/widgets/Terminal.vala"
	_tmp4_ = g_strdup_printf ("process-completed-%u-%u", _tmp2_, _tmp3_);
#line 352 "../src/widgets/Terminal.vala"
	result = _tmp4_;
#line 352 "../src/widgets/Terminal.vala"
	return result;
#line 1728 "Terminal.c"
}

static void
terminal_terminal_on_attention_received (TerminalTerminal* self)
{
#line 355 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 356 "../src/widgets/Terminal.vala"
	terminal_terminal_set_needs_attention (self, FALSE);
#line 357 "../src/widgets/Terminal.vala"
	terminal_terminal_withdraw_command_completed_notification (self);
#line 1740 "Terminal.c"
}

static gboolean
_terminal_terminal_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                        guint keyval,
                                                                        guint keycode,
                                                                        GdkModifierType state,
                                                                        gpointer self)
{
	gboolean result;
	result = terminal_terminal_on_key_pressed ((TerminalTerminal*) self, keyval, keycode, state);
#line 362 "../src/widgets/Terminal.vala"
	return result;
#line 1754 "Terminal.c"
}

static gpointer
_gdk_event_ref0 (gpointer self)
{
#line 369 "../src/widgets/Terminal.vala"
	return self ? gdk_event_ref (self) : NULL;
#line 1762 "Terminal.c"
}

static void
__lambda11_ (TerminalTerminal* self,
             GtkGestureClick* gesture,
             gint n_clicked,
             gdouble x,
             gdouble y)
{
	GdkEvent* event = NULL;
	GdkEvent* _tmp0_;
	GdkEvent* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* pattern = NULL;
	gchar* _tmp6_;
	gboolean _tmp7_ = FALSE;
	GdkEvent* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 368 "../src/widgets/Terminal.vala"
	g_return_if_fail (gesture != NULL);
#line 369 "../src/widgets/Terminal.vala"
	_tmp0_ = gtk_event_controller_get_current_event ((GtkEventController*) gesture);
#line 369 "../src/widgets/Terminal.vala"
	_tmp1_ = _gdk_event_ref0 (_tmp0_);
#line 369 "../src/widgets/Terminal.vala"
	event = _tmp1_;
#line 370 "../src/widgets/Terminal.vala"
	_tmp3_ = vte_terminal_check_match_at ((VteTerminal*) self, x, y, NULL);
#line 370 "../src/widgets/Terminal.vala"
	_tmp2_ = _tmp3_;
#line 370 "../src/widgets/Terminal.vala"
	if (_tmp2_ == NULL) {
#line 1796 "Terminal.c"
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 370 "../src/widgets/Terminal.vala"
		g_object_get ((VteTerminal*) self, "hyperlink-hover-uri", &_tmp4_, NULL);
#line 370 "../src/widgets/Terminal.vala"
		_tmp5_ = _tmp4_;
#line 370 "../src/widgets/Terminal.vala"
		_g_free0 (_tmp2_);
#line 370 "../src/widgets/Terminal.vala"
		_tmp2_ = _tmp5_;
#line 1807 "Terminal.c"
	}
#line 370 "../src/widgets/Terminal.vala"
	_tmp6_ = _tmp2_;
#line 370 "../src/widgets/Terminal.vala"
	_tmp2_ = NULL;
#line 370 "../src/widgets/Terminal.vala"
	pattern = _tmp6_;
#line 373 "../src/widgets/Terminal.vala"
	_tmp8_ = event;
#line 373 "../src/widgets/Terminal.vala"
	if ((gdk_event_get_modifier_state (_tmp8_) & GDK_CONTROL_MASK) == 0) {
#line 373 "../src/widgets/Terminal.vala"
		_tmp7_ = TRUE;
#line 1821 "Terminal.c"
	} else {
		const gchar* _tmp9_;
#line 374 "../src/widgets/Terminal.vala"
		_tmp9_ = pattern;
#line 374 "../src/widgets/Terminal.vala"
		_tmp7_ = _tmp9_ == NULL;
#line 1828 "Terminal.c"
	}
#line 372 "../src/widgets/Terminal.vala"
	if (_tmp7_) {
#line 376 "../src/widgets/Terminal.vala"
		_g_free0 (pattern);
#line 376 "../src/widgets/Terminal.vala"
		_g_free0 (_tmp2_);
#line 376 "../src/widgets/Terminal.vala"
		_gdk_event_unref0 (event);
#line 376 "../src/widgets/Terminal.vala"
		return;
#line 1840 "Terminal.c"
	}
	{
		const gchar* _tmp10_;
#line 380 "../src/widgets/Terminal.vala"
		_tmp10_ = pattern;
#line 380 "../src/widgets/Terminal.vala"
		g_app_info_launch_default_for_uri (_tmp10_, NULL, &_inner_error0_);
#line 380 "../src/widgets/Terminal.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1850 "Terminal.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 379 "../src/widgets/Terminal.vala"
		e = _inner_error0_;
#line 379 "../src/widgets/Terminal.vala"
		_inner_error0_ = NULL;
#line 383 "../src/widgets/Terminal.vala"
		_tmp11_ = e;
#line 383 "../src/widgets/Terminal.vala"
		_tmp12_ = _tmp11_->message;
#line 383 "../src/widgets/Terminal.vala"
		g_warning ("Terminal.vala:383: Failed to open link %s", _tmp12_);
#line 379 "../src/widgets/Terminal.vala"
		_g_error_free0 (e);
#line 1872 "Terminal.c"
	}
	__finally0:
#line 379 "../src/widgets/Terminal.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 379 "../src/widgets/Terminal.vala"
		_g_free0 (pattern);
#line 379 "../src/widgets/Terminal.vala"
		_g_free0 (_tmp2_);
#line 379 "../src/widgets/Terminal.vala"
		_gdk_event_unref0 (event);
#line 379 "../src/widgets/Terminal.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 379 "../src/widgets/Terminal.vala"
		g_clear_error (&_inner_error0_);
#line 379 "../src/widgets/Terminal.vala"
		return;
#line 1889 "Terminal.c"
	}
#line 368 "../src/widgets/Terminal.vala"
	_g_free0 (pattern);
#line 368 "../src/widgets/Terminal.vala"
	_g_free0 (_tmp2_);
#line 368 "../src/widgets/Terminal.vala"
	_gdk_event_unref0 (event);
#line 1897 "Terminal.c"
}

static void
___lambda11__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                        gint n_press,
                                        gdouble x,
                                        gdouble y,
                                        gpointer self)
{
#line 368 "../src/widgets/Terminal.vala"
	__lambda11_ ((TerminalTerminal*) self, _sender, n_press, x, y);
#line 1909 "Terminal.c"
}

static void
__lambda12_ (TerminalTerminal* self)
{
#line 390 "../src/widgets/Terminal.vala"
	g_object_notify ((GObject*) self, "user-scrollback-lines");
#line 1917 "Terminal.c"
}

static void
___lambda12__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 388 "../src/widgets/Terminal.vala"
	__lambda12_ ((TerminalTerminal*) self);
#line 1927 "Terminal.c"
}

static void
__lambda13_ (TerminalTerminal* self)
{
#line 395 "../src/widgets/Terminal.vala"
	g_object_notify ((GObject*) self, "user-scrollback-lines");
#line 1935 "Terminal.c"
}

static void
___lambda13__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 393 "../src/widgets/Terminal.vala"
	__lambda13_ ((TerminalTerminal*) self);
#line 1945 "Terminal.c"
}

static void
___lambda15_ (TerminalTerminal* self)
{
#line 405 "../src/widgets/Terminal.vala"
	terminal_terminal_on_attention_received (self);
#line 406 "../src/widgets/Terminal.vala"
	self->priv->attention_timer = (guint) 0;
#line 1955 "Terminal.c"
}

static void
____lambda15__gsource_once_func (gpointer self)
{
#line 404 "../src/widgets/Terminal.vala"
	___lambda15_ ((TerminalTerminal*) self);
#line 1963 "Terminal.c"
}

static void
__lambda14_ (TerminalTerminal* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 399 "../src/widgets/Terminal.vala"
	if (self->priv->attention_timer > ((guint) 0)) {
#line 400 "../src/widgets/Terminal.vala"
		g_source_remove (self->priv->attention_timer);
#line 401 "../src/widgets/Terminal.vala"
		self->priv->attention_timer = (guint) 0;
#line 1977 "Terminal.c"
	}
#line 403 "../src/widgets/Terminal.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp0_, NULL);
#line 403 "../src/widgets/Terminal.vala"
	_tmp1_ = _tmp0_;
#line 403 "../src/widgets/Terminal.vala"
	if (_tmp1_) {
#line 404 "../src/widgets/Terminal.vala"
		self->priv->attention_timer = g_timeout_add_once ((guint) (2 * 1000), ____lambda15__gsource_once_func, self);
#line 1987 "Terminal.c"
	}
}

static void
___lambda14__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 398 "../src/widgets/Terminal.vala"
	__lambda14_ ((TerminalTerminal*) self);
#line 1998 "Terminal.c"
}

static void
terminal_terminal_connect_signals (TerminalTerminal* self)
{
	GtkEventControllerKey* kpcontroller = NULL;
	GtkEventControllerKey* _tmp0_;
	GtkEventController* _tmp1_;
	GtkGestureClick* left_click_controller = NULL;
	GtkGestureClick* _tmp2_ = NULL;
	GtkEventController* _tmp3_;
	TerminalSettings* _tmp4_;
	TerminalSettings* _tmp5_;
#line 360 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 361 "../src/widgets/Terminal.vala"
	_tmp0_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 361 "../src/widgets/Terminal.vala"
	kpcontroller = _tmp0_;
#line 362 "../src/widgets/Terminal.vala"
	g_signal_connect_object (kpcontroller, "key-pressed", (GCallback) _terminal_terminal_on_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
#line 363 "../src/widgets/Terminal.vala"
	_tmp1_ = _g_object_ref0 ((GtkEventController*) kpcontroller);
#line 363 "../src/widgets/Terminal.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp1_);
#line 365 "../src/widgets/Terminal.vala"
	_tmp2_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 365 "../src/widgets/Terminal.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp2_, (guint) GDK_BUTTON_PRIMARY);
#line 365 "../src/widgets/Terminal.vala"
	left_click_controller = _tmp2_;
#line 368 "../src/widgets/Terminal.vala"
	g_signal_connect_object (left_click_controller, "pressed", (GCallback) ___lambda11__gtk_gesture_click_pressed, self, 0);
#line 386 "../src/widgets/Terminal.vala"
	_tmp3_ = _g_object_ref0 ((GtkEventController*) left_click_controller);
#line 386 "../src/widgets/Terminal.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp3_);
#line 388 "../src/widgets/Terminal.vala"
	_tmp4_ = self->priv->settings;
#line 388 "../src/widgets/Terminal.vala"
	g_signal_connect_object ((GObject*) _tmp4_, "notify::scrollback-lines", (GCallback) ___lambda12__g_object_notify, self, 0);
#line 393 "../src/widgets/Terminal.vala"
	_tmp5_ = self->priv->settings;
#line 393 "../src/widgets/Terminal.vala"
	g_signal_connect_object ((GObject*) _tmp5_, "notify::scrollback-mode", (GCallback) ___lambda13__g_object_notify, self, 0);
#line 398 "../src/widgets/Terminal.vala"
	g_signal_connect_object ((GObject*) self, "notify::has-focus", (GCallback) ___lambda14__g_object_notify, self, 0);
#line 360 "../src/widgets/Terminal.vala"
	_g_object_unref0 (left_click_controller);
#line 360 "../src/widgets/Terminal.vala"
	_g_object_unref0 (kpcontroller);
#line 2050 "Terminal.c"
}

static void
_g_free0_ (gpointer var)
{
#line 413 "../src/widgets/Terminal.vala"
	var = (g_free (var), NULL);
#line 2058 "Terminal.c"
}

static void
_vala_gchar_free_function_content_of (gpointer data)
{
	gchar* self;
#line 413 "../src/widgets/Terminal.vala"
	self = *((gchar**) data);
#line 413 "../src/widgets/Terminal.vala"
	_g_free0_ (self);
#line 2069 "Terminal.c"
}

static void
__terminal_terminal_on_spawn_finished_vte_terminal_spawn_async_callback (VteTerminal* terminal,
                                                                         GPid pid,
                                                                         GError* _error_,
                                                                         gpointer self)
{
#line 495 "../src/widgets/Terminal.vala"
	_terminal_terminal_on_spawn_finished ((TerminalTerminal*) self, terminal, pid, _error_);
#line 495 "../src/widgets/Terminal.vala"
	g_object_unref (self);
#line 2082 "Terminal.c"
}

static void
terminal_terminal_spawn (TerminalTerminal* self,
                         const gchar* command,
                         const gchar* cwd,
                         GError** error)
{
	GArray* argv = NULL;
	GArray* _tmp0_;
	GArray* envv = NULL;
	GArray* _tmp1_;
	VtePtyFlags flags = 0U;
	TerminalSettings* settings = NULL;
	TerminalSettings* _tmp2_;
	gchar** custom_shell_commandv = NULL;
	gint custom_shell_commandv_length1;
	gint _custom_shell_commandv_size_;
	gchar* shell = NULL;
	gboolean _tmp3_ = FALSE;
	TerminalSettings* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gchar** tmp_envv = NULL;
	gchar** _tmp15_;
	gchar** _tmp16_;
	gint tmp_envv_length1;
	gint _tmp_envv_size_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	gchar** _tmp22_;
	gint _tmp22__length1;
	GArray* _tmp26_;
	gpointer* _tmp27_;
	gint _tmp27__length1;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar** _tmp30_;
	gint _tmp30__length1;
	GArray* _tmp48_;
	gpointer* _tmp49_;
	gint _tmp49__length1;
	GArray* _tmp50_;
	gpointer* _tmp51_;
	gint _tmp51__length1;
	GError* _inner_error0_ = NULL;
#line 412 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 413 "../src/widgets/Terminal.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (gchar*));
#line 413 "../src/widgets/Terminal.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_gchar_free_function_content_of);
#line 413 "../src/widgets/Terminal.vala"
	argv = _tmp0_;
#line 414 "../src/widgets/Terminal.vala"
	_tmp1_ = g_array_new (TRUE, TRUE, sizeof (gchar*));
#line 414 "../src/widgets/Terminal.vala"
	g_array_set_clear_func (_tmp1_, (GDestroyNotify) _vala_gchar_free_function_content_of);
#line 414 "../src/widgets/Terminal.vala"
	envv = _tmp1_;
#line 415 "../src/widgets/Terminal.vala"
	flags = VTE_PTY_DEFAULT;
#line 417 "../src/widgets/Terminal.vala"
	_tmp2_ = terminal_settings_get_default ();
#line 417 "../src/widgets/Terminal.vala"
	settings = _tmp2_;
#line 418 "../src/widgets/Terminal.vala"
	custom_shell_commandv = NULL;
#line 418 "../src/widgets/Terminal.vala"
	custom_shell_commandv_length1 = 0;
#line 418 "../src/widgets/Terminal.vala"
	_custom_shell_commandv_size_ = custom_shell_commandv_length1;
#line 423 "../src/widgets/Terminal.vala"
	_tmp4_ = settings;
#line 423 "../src/widgets/Terminal.vala"
	_tmp5_ = terminal_settings_get_use_custom_command (_tmp4_);
#line 423 "../src/widgets/Terminal.vala"
	_tmp6_ = _tmp5_;
#line 423 "../src/widgets/Terminal.vala"
	if (_tmp6_) {
#line 2163 "Terminal.c"
		TerminalSettings* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 424 "../src/widgets/Terminal.vala"
		_tmp7_ = settings;
#line 424 "../src/widgets/Terminal.vala"
		_tmp8_ = terminal_settings_get_custom_shell_command (_tmp7_);
#line 424 "../src/widgets/Terminal.vala"
		_tmp9_ = _tmp8_;
#line 424 "../src/widgets/Terminal.vala"
		_tmp3_ = g_strcmp0 (_tmp9_, "") != 0;
#line 2175 "Terminal.c"
	} else {
#line 423 "../src/widgets/Terminal.vala"
		_tmp3_ = FALSE;
#line 2179 "Terminal.c"
	}
#line 422 "../src/widgets/Terminal.vala"
	if (_tmp3_) {
#line 2183 "Terminal.c"
		TerminalSettings* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar** _tmp13_ = NULL;
		gint _tmp14_ = 0;
#line 426 "../src/widgets/Terminal.vala"
		_tmp10_ = settings;
#line 426 "../src/widgets/Terminal.vala"
		_tmp11_ = terminal_settings_get_custom_shell_command (_tmp10_);
#line 426 "../src/widgets/Terminal.vala"
		_tmp12_ = _tmp11_;
#line 426 "../src/widgets/Terminal.vala"
		g_shell_parse_argv (_tmp12_, &_tmp14_, &_tmp13_, &_inner_error0_);
#line 426 "../src/widgets/Terminal.vala"
		custom_shell_commandv = (_vala_array_free (custom_shell_commandv, custom_shell_commandv_length1, (GDestroyNotify) g_free), NULL);
#line 426 "../src/widgets/Terminal.vala"
		custom_shell_commandv = _tmp13_;
#line 426 "../src/widgets/Terminal.vala"
		custom_shell_commandv_length1 = _tmp14_;
#line 426 "../src/widgets/Terminal.vala"
		_custom_shell_commandv_size_ = custom_shell_commandv_length1;
#line 426 "../src/widgets/Terminal.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 426 "../src/widgets/Terminal.vala"
			g_propagate_error (error, _inner_error0_);
#line 426 "../src/widgets/Terminal.vala"
			_g_free0 (shell);
#line 426 "../src/widgets/Terminal.vala"
			custom_shell_commandv = (_vala_array_free (custom_shell_commandv, custom_shell_commandv_length1, (GDestroyNotify) g_free), NULL);
#line 426 "../src/widgets/Terminal.vala"
			_g_object_unref0 (settings);
#line 426 "../src/widgets/Terminal.vala"
			_g_array_unref0 (envv);
#line 426 "../src/widgets/Terminal.vala"
			_g_array_unref0 (argv);
#line 426 "../src/widgets/Terminal.vala"
			return;
#line 2221 "Terminal.c"
		}
	}
#line 445 "../src/widgets/Terminal.vala"
	_tmp16_ = _tmp15_ = g_get_environ ();
#line 445 "../src/widgets/Terminal.vala"
	tmp_envv = _tmp16_;
#line 445 "../src/widgets/Terminal.vala"
	tmp_envv_length1 = _vala_array_length (_tmp15_);
#line 445 "../src/widgets/Terminal.vala"
	_tmp_envv_size_ = tmp_envv_length1;
#line 447 "../src/widgets/Terminal.vala"
	_tmp17_ = tmp_envv;
#line 447 "../src/widgets/Terminal.vala"
	_tmp17__length1 = tmp_envv_length1;
#line 2236 "Terminal.c"
	{
		gchar** env_collection = NULL;
		gint env_collection_length1 = 0;
		gint _env_collection_size_ = 0;
		gint env_it = 0;
#line 447 "../src/widgets/Terminal.vala"
		env_collection = _tmp17_;
#line 447 "../src/widgets/Terminal.vala"
		env_collection_length1 = _tmp17__length1;
#line 447 "../src/widgets/Terminal.vala"
		for (env_it = 0; env_it < env_collection_length1; env_it = env_it + 1) {
#line 2248 "Terminal.c"
			gchar* _tmp18_;
			gchar* env = NULL;
#line 447 "../src/widgets/Terminal.vala"
			_tmp18_ = g_strdup (env_collection[env_it]);
#line 447 "../src/widgets/Terminal.vala"
			env = _tmp18_;
#line 2255 "Terminal.c"
			{
				GArray* _tmp19_;
				const gchar* _tmp20_;
				gchar* _tmp21_;
#line 448 "../src/widgets/Terminal.vala"
				_tmp19_ = envv;
#line 448 "../src/widgets/Terminal.vala"
				_tmp20_ = env;
#line 448 "../src/widgets/Terminal.vala"
				_tmp21_ = g_strdup (_tmp20_);
#line 448 "../src/widgets/Terminal.vala"
				g_array_append_val (_tmp19_, _tmp21_);
#line 447 "../src/widgets/Terminal.vala"
				_g_free0 (env);
#line 2270 "Terminal.c"
			}
		}
	}
#line 451 "../src/widgets/Terminal.vala"
	_tmp22_ = terminal_terminal_blackbox_envv;
#line 451 "../src/widgets/Terminal.vala"
	_tmp22__length1 = terminal_terminal_blackbox_envv_length1;
#line 2278 "Terminal.c"
	{
		gchar** env_collection = NULL;
		gint env_collection_length1 = 0;
		gint _env_collection_size_ = 0;
		gint env_it = 0;
#line 451 "../src/widgets/Terminal.vala"
		env_collection = _tmp22_;
#line 451 "../src/widgets/Terminal.vala"
		env_collection_length1 = _tmp22__length1;
#line 451 "../src/widgets/Terminal.vala"
		for (env_it = 0; env_it < env_collection_length1; env_it = env_it + 1) {
#line 2290 "Terminal.c"
			const gchar* env = NULL;
#line 451 "../src/widgets/Terminal.vala"
			env = env_collection[env_it];
#line 2294 "Terminal.c"
			{
				GArray* _tmp23_;
				const gchar* _tmp24_;
				gchar* _tmp25_;
#line 452 "../src/widgets/Terminal.vala"
				_tmp23_ = envv;
#line 452 "../src/widgets/Terminal.vala"
				_tmp24_ = env;
#line 452 "../src/widgets/Terminal.vala"
				_tmp25_ = g_strdup (_tmp24_);
#line 452 "../src/widgets/Terminal.vala"
				g_array_append_val (_tmp23_, _tmp25_);
#line 2307 "Terminal.c"
			}
		}
	}
#line 455 "../src/widgets/Terminal.vala"
	_tmp26_ = envv;
#line 455 "../src/widgets/Terminal.vala"
	_tmp27_ = _tmp26_->data;
#line 455 "../src/widgets/Terminal.vala"
	_tmp27__length1 = _tmp26_->len;
#line 455 "../src/widgets/Terminal.vala"
	_tmp28_ = g_environ_getenv (_tmp27_, "SHELL");
#line 455 "../src/widgets/Terminal.vala"
	_tmp29_ = g_strdup (_tmp28_);
#line 455 "../src/widgets/Terminal.vala"
	_g_free0 (shell);
#line 455 "../src/widgets/Terminal.vala"
	shell = _tmp29_;
#line 458 "../src/widgets/Terminal.vala"
	_tmp30_ = custom_shell_commandv;
#line 458 "../src/widgets/Terminal.vala"
	_tmp30__length1 = custom_shell_commandv_length1;
#line 458 "../src/widgets/Terminal.vala"
	if (_tmp30_ != NULL) {
#line 2331 "Terminal.c"
		gchar** _tmp31_;
		gint _tmp31__length1;
#line 459 "../src/widgets/Terminal.vala"
		_tmp31_ = custom_shell_commandv;
#line 459 "../src/widgets/Terminal.vala"
		_tmp31__length1 = custom_shell_commandv_length1;
#line 2338 "Terminal.c"
		{
			gchar** s_collection = NULL;
			gint s_collection_length1 = 0;
			gint _s_collection_size_ = 0;
			gint s_it = 0;
#line 459 "../src/widgets/Terminal.vala"
			s_collection = _tmp31_;
#line 459 "../src/widgets/Terminal.vala"
			s_collection_length1 = _tmp31__length1;
#line 459 "../src/widgets/Terminal.vala"
			for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
#line 2350 "Terminal.c"
				const gchar* s = NULL;
#line 459 "../src/widgets/Terminal.vala"
				s = s_collection[s_it];
#line 2354 "Terminal.c"
				{
					GArray* _tmp32_;
					const gchar* _tmp33_;
					gchar* _tmp34_;
#line 460 "../src/widgets/Terminal.vala"
					_tmp32_ = argv;
#line 460 "../src/widgets/Terminal.vala"
					_tmp33_ = s;
#line 460 "../src/widgets/Terminal.vala"
					_tmp34_ = g_strdup (_tmp33_);
#line 460 "../src/widgets/Terminal.vala"
					g_array_append_val (_tmp32_, _tmp34_);
#line 2367 "Terminal.c"
				}
			}
		}
	} else {
		GArray* _tmp35_;
		const gchar* _tmp36_;
		gchar* _tmp37_;
		gboolean _tmp38_ = FALSE;
		TerminalSettings* _tmp39_;
		gboolean _tmp40_;
		gboolean _tmp41_;
#line 464 "../src/widgets/Terminal.vala"
		_tmp35_ = argv;
#line 464 "../src/widgets/Terminal.vala"
		_tmp36_ = shell;
#line 464 "../src/widgets/Terminal.vala"
		_tmp37_ = g_strdup (_tmp36_);
#line 464 "../src/widgets/Terminal.vala"
		g_array_append_val (_tmp35_, _tmp37_);
#line 465 "../src/widgets/Terminal.vala"
		_tmp39_ = settings;
#line 465 "../src/widgets/Terminal.vala"
		_tmp40_ = terminal_settings_get_command_as_login_shell (_tmp39_);
#line 465 "../src/widgets/Terminal.vala"
		_tmp41_ = _tmp40_;
#line 465 "../src/widgets/Terminal.vala"
		if (_tmp41_) {
#line 465 "../src/widgets/Terminal.vala"
			_tmp38_ = command == NULL;
#line 2397 "Terminal.c"
		} else {
#line 465 "../src/widgets/Terminal.vala"
			_tmp38_ = FALSE;
#line 2401 "Terminal.c"
		}
#line 465 "../src/widgets/Terminal.vala"
		if (_tmp38_) {
#line 2405 "Terminal.c"
			GArray* _tmp42_;
			gchar* _tmp43_;
#line 466 "../src/widgets/Terminal.vala"
			_tmp42_ = argv;
#line 466 "../src/widgets/Terminal.vala"
			_tmp43_ = g_strdup ("--login");
#line 466 "../src/widgets/Terminal.vala"
			g_array_append_val (_tmp42_, _tmp43_);
#line 2414 "Terminal.c"
		}
	}
#line 469 "../src/widgets/Terminal.vala"
	if (command != NULL) {
#line 2419 "Terminal.c"
		GArray* _tmp44_;
		gchar* _tmp45_;
		GArray* _tmp46_;
		gchar* _tmp47_;
#line 470 "../src/widgets/Terminal.vala"
		_tmp44_ = argv;
#line 470 "../src/widgets/Terminal.vala"
		_tmp45_ = g_strdup ("-c");
#line 470 "../src/widgets/Terminal.vala"
		g_array_append_val (_tmp44_, _tmp45_);
#line 471 "../src/widgets/Terminal.vala"
		_tmp46_ = argv;
#line 471 "../src/widgets/Terminal.vala"
		_tmp47_ = g_strdup (command);
#line 471 "../src/widgets/Terminal.vala"
		g_array_append_val (_tmp46_, _tmp47_);
#line 2436 "Terminal.c"
	}
#line 495 "../src/widgets/Terminal.vala"
	_tmp48_ = argv;
#line 495 "../src/widgets/Terminal.vala"
	_tmp49_ = _tmp48_->data;
#line 495 "../src/widgets/Terminal.vala"
	_tmp49__length1 = _tmp48_->len;
#line 495 "../src/widgets/Terminal.vala"
	_tmp50_ = envv;
#line 495 "../src/widgets/Terminal.vala"
	_tmp51_ = _tmp50_->data;
#line 495 "../src/widgets/Terminal.vala"
	_tmp51__length1 = _tmp50_->len;
#line 495 "../src/widgets/Terminal.vala"
	vte_terminal_spawn_async ((VteTerminal*) self, flags, cwd, _tmp49_, _tmp51_, 0, NULL, NULL, NULL, -1, NULL, __terminal_terminal_on_spawn_finished_vte_terminal_spawn_async_callback, g_object_ref (self));
#line 412 "../src/widgets/Terminal.vala"
	tmp_envv = (_vala_array_free (tmp_envv, tmp_envv_length1, (GDestroyNotify) g_free), NULL);
#line 412 "../src/widgets/Terminal.vala"
	_g_free0 (shell);
#line 412 "../src/widgets/Terminal.vala"
	custom_shell_commandv = (_vala_array_free (custom_shell_commandv, custom_shell_commandv_length1, (GDestroyNotify) g_free), NULL);
#line 412 "../src/widgets/Terminal.vala"
	_g_object_unref0 (settings);
#line 412 "../src/widgets/Terminal.vala"
	_g_array_unref0 (envv);
#line 412 "../src/widgets/Terminal.vala"
	_g_array_unref0 (argv);
#line 2464 "Terminal.c"
}

static void
_terminal_terminal_on_spawn_finished (TerminalTerminal* self,
                                      VteTerminal* t,
                                      GPid pid,
                                      GError* _error_)
{
#line 510 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 510 "../src/widgets/Terminal.vala"
	g_return_if_fail (t != NULL);
#line 511 "../src/widgets/Terminal.vala"
	if (_error_ == NULL) {
#line 512 "../src/widgets/Terminal.vala"
		terminal_terminal_set_pid (self, pid);
#line 513 "../src/widgets/Terminal.vala"
		terminal_terminal_on_spawn_finished (self);
#line 2483 "Terminal.c"
	} else {
		const gchar* _tmp0_;
#line 516 "../src/widgets/Terminal.vala"
		_tmp0_ = _error_->message;
#line 516 "../src/widgets/Terminal.vala"
		g_signal_emit (self, terminal_terminal_signals[TERMINAL_TERMINAL_SPAWN_FAILED_SIGNAL], 0, _tmp0_);
#line 2490 "Terminal.c"
	}
}

static void
__lambda16_ (TerminalTerminal* self,
             TerminalProcess* _process)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 532 "../src/widgets/Terminal.vala"
	g_return_if_fail (_process != NULL);
#line 533 "../src/widgets/Terminal.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp1_, NULL);
#line 533 "../src/widgets/Terminal.vala"
	_tmp2_ = _tmp1_;
#line 533 "../src/widgets/Terminal.vala"
	if (!_tmp2_) {
#line 2509 "Terminal.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 533 "../src/widgets/Terminal.vala"
		_tmp3_ = terminal_process_get_last_foreground_task_command (_process);
#line 533 "../src/widgets/Terminal.vala"
		_tmp4_ = _tmp3_;
#line 533 "../src/widgets/Terminal.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 2518 "Terminal.c"
	} else {
#line 533 "../src/widgets/Terminal.vala"
		_tmp0_ = FALSE;
#line 2522 "Terminal.c"
	}
#line 533 "../src/widgets/Terminal.vala"
	if (_tmp0_) {
#line 534 "../src/widgets/Terminal.vala"
		terminal_terminal_set_needs_attention (self, TRUE);
#line 535 "../src/widgets/Terminal.vala"
		terminal_terminal_send_command_completed_notification (self);
#line 2530 "Terminal.c"
	}
}

static void
___lambda16__terminal_process_foreground_task_finished (TerminalProcess* _sender,
                                                        gpointer self)
{
#line 532 "../src/widgets/Terminal.vala"
	__lambda16_ ((TerminalTerminal*) self, _sender);
#line 2540 "Terminal.c"
}

static TerminalProcessContext*
_terminal_process_context_dup (TerminalProcessContext* self)
{
	TerminalProcessContext* dup;
#line 540 "../src/widgets/Terminal.vala"
	dup = g_new0 (TerminalProcessContext, 1);
#line 540 "../src/widgets/Terminal.vala"
	memcpy (dup, self, sizeof (TerminalProcessContext));
#line 540 "../src/widgets/Terminal.vala"
	return dup;
#line 2553 "Terminal.c"
}

static gpointer
__terminal_process_context_dup0 (gpointer self)
{
#line 540 "../src/widgets/Terminal.vala"
	return self ? _terminal_process_context_dup (self) : NULL;
#line 2561 "Terminal.c"
}

static void
__lambda17_ (TerminalTerminal* self,
             GObject* __process,
             GParamSpec* spec)
{
	TerminalProcess* _tmp0_ = NULL;
	TerminalProcess* _tmp1_;
	TerminalProcessContext* _tmp2_ = NULL;
	TerminalProcessContext* _tmp6_ = NULL;
	TerminalProcessContext* _tmp7_;
	TerminalProcessContext* context = NULL;
	TerminalProcessContext* _tmp10_;
#line 539 "../src/widgets/Terminal.vala"
	g_return_if_fail (__process != NULL);
#line 539 "../src/widgets/Terminal.vala"
	g_return_if_fail (spec != NULL);
#line 540 "../src/widgets/Terminal.vala"
	_tmp1_ = self->priv->_process;
#line 540 "../src/widgets/Terminal.vala"
	_tmp0_ = TERMINAL_IS_PROCESS (_tmp1_) ? ((TerminalProcess*) _tmp1_) : NULL;
#line 540 "../src/widgets/Terminal.vala"
	_tmp2_ = NULL;
#line 540 "../src/widgets/Terminal.vala"
	if (_tmp0_ != NULL) {
#line 2588 "Terminal.c"
		TerminalProcessContext _tmp3_;
		TerminalProcessContext _tmp4_;
		TerminalProcessContext* _tmp5_;
#line 540 "../src/widgets/Terminal.vala"
		_tmp3_ = terminal_process_get_context (_tmp0_);
#line 540 "../src/widgets/Terminal.vala"
		_tmp4_ = _tmp3_;
#line 540 "../src/widgets/Terminal.vala"
		_tmp5_ = __terminal_process_context_dup0 (&_tmp4_);
#line 540 "../src/widgets/Terminal.vala"
		_g_free0 (_tmp2_);
#line 540 "../src/widgets/Terminal.vala"
		_tmp2_ = _tmp5_;
#line 2602 "Terminal.c"
	}
#line 540 "../src/widgets/Terminal.vala"
	_tmp7_ = _tmp2_;
#line 540 "../src/widgets/Terminal.vala"
	_tmp2_ = NULL;
#line 540 "../src/widgets/Terminal.vala"
	_tmp6_ = _tmp7_;
#line 540 "../src/widgets/Terminal.vala"
	if (_tmp6_ == NULL) {
#line 2612 "Terminal.c"
		TerminalProcessContext _tmp8_;
		TerminalProcessContext* _tmp9_;
#line 540 "../src/widgets/Terminal.vala"
		_tmp8_ = TERMINAL_PROCESS_CONTEXT_DEFAULT;
#line 540 "../src/widgets/Terminal.vala"
		_tmp9_ = __terminal_process_context_dup0 (&_tmp8_);
#line 540 "../src/widgets/Terminal.vala"
		_g_free0 (_tmp6_);
#line 540 "../src/widgets/Terminal.vala"
		_tmp6_ = _tmp9_;
#line 2623 "Terminal.c"
	}
#line 540 "../src/widgets/Terminal.vala"
	_tmp10_ = _tmp6_;
#line 540 "../src/widgets/Terminal.vala"
	_tmp6_ = NULL;
#line 540 "../src/widgets/Terminal.vala"
	context = _tmp10_;
#line 542 "../src/widgets/Terminal.vala"
	g_signal_emit (self, terminal_terminal_signals[TERMINAL_TERMINAL_CONTEXT_CHANGED_SIGNAL], 0, *context);
#line 539 "../src/widgets/Terminal.vala"
	_g_free0 (context);
#line 539 "../src/widgets/Terminal.vala"
	_g_free0 (_tmp6_);
#line 539 "../src/widgets/Terminal.vala"
	_g_free0 (_tmp2_);
#line 2639 "Terminal.c"
}

static void
___lambda17__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 539 "../src/widgets/Terminal.vala"
	__lambda17_ ((TerminalTerminal*) self, _sender, pspec);
#line 2649 "Terminal.c"
}

static void
terminal_terminal_on_spawn_finished (TerminalTerminal* self)
{
	VtePty* _tmp0_;
	VtePty* _tmp1_;
	GPid _tmp2_;
	TerminalProcess* _tmp3_ = NULL;
	TerminalProcess* _tmp4_;
	TerminalProcess* _tmp5_;
	TerminalProcess* _tmp6_;
	TerminalProcessWatcher* _tmp7_;
	TerminalProcessWatcher* _tmp8_;
	TerminalProcess* _tmp9_;
	TerminalProcess* _tmp10_;
	TerminalProcessContext _tmp11_;
	TerminalProcessContext _tmp12_;
#line 521 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 522 "../src/widgets/Terminal.vala"
	if (self->priv->_pid < ((GPid) 0)) {
#line 523 "../src/widgets/Terminal.vala"
		return;
#line 2674 "Terminal.c"
	}
#line 526 "../src/widgets/Terminal.vala"
	_tmp0_ = vte_terminal_get_pty ((VteTerminal*) self);
#line 526 "../src/widgets/Terminal.vala"
	_tmp1_ = _tmp0_;
#line 526 "../src/widgets/Terminal.vala"
	_tmp2_ = self->priv->_pid;
#line 526 "../src/widgets/Terminal.vala"
	_tmp3_ = terminal_process_new ();
#line 526 "../src/widgets/Terminal.vala"
	terminal_process_set_terminal_fd (_tmp3_, vte_pty_get_fd (_tmp1_));
#line 526 "../src/widgets/Terminal.vala"
	terminal_process_set_pid (_tmp3_, _tmp2_);
#line 526 "../src/widgets/Terminal.vala"
	terminal_process_set_foreground_pid (_tmp3_, (GPid) -1);
#line 526 "../src/widgets/Terminal.vala"
	_tmp4_ = _tmp3_;
#line 526 "../src/widgets/Terminal.vala"
	terminal_terminal_set_process (self, _tmp4_);
#line 526 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_tmp4_);
#line 532 "../src/widgets/Terminal.vala"
	_tmp5_ = self->priv->_process;
#line 532 "../src/widgets/Terminal.vala"
	g_signal_connect_object (_tmp5_, "foreground-task-finished", (GCallback) ___lambda16__terminal_process_foreground_task_finished, self, 0);
#line 539 "../src/widgets/Terminal.vala"
	_tmp6_ = self->priv->_process;
#line 539 "../src/widgets/Terminal.vala"
	g_signal_connect_object ((GObject*) _tmp6_, "notify::context", (GCallback) ___lambda17__g_object_notify, self, 0);
#line 552 "../src/widgets/Terminal.vala"
	_tmp7_ = terminal_process_watcher_get_instance ();
#line 552 "../src/widgets/Terminal.vala"
	_tmp8_ = _tmp7_;
#line 552 "../src/widgets/Terminal.vala"
	_tmp9_ = self->priv->_process;
#line 552 "../src/widgets/Terminal.vala"
	terminal_process_watcher_watch (_tmp8_, _tmp9_);
#line 552 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_tmp8_);
#line 554 "../src/widgets/Terminal.vala"
	_tmp10_ = self->priv->_process;
#line 554 "../src/widgets/Terminal.vala"
	_tmp11_ = terminal_process_get_context (_tmp10_);
#line 554 "../src/widgets/Terminal.vala"
	_tmp12_ = _tmp11_;
#line 554 "../src/widgets/Terminal.vala"
	g_signal_emit (self, terminal_terminal_signals[TERMINAL_TERMINAL_CONTEXT_CHANGED_SIGNAL], 0, _tmp12_);
#line 2722 "Terminal.c"
}

static void
terminal_terminal_spawn_on_flatpak_data_free (gpointer _data)
{
	TerminalTerminalSpawnOnFlatpakData* _data_;
	_data_ = _data;
#line 21 "../src/widgets/Terminal.vala"
	_g_free0 (_data_->cwd);
#line 21 "../src/widgets/Terminal.vala"
	_g_array_unref0 (_data_->argv);
#line 21 "../src/widgets/Terminal.vala"
	_g_array_unref0 (_data_->envv);
#line 21 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_data_->self);
#line 21 "../src/widgets/Terminal.vala"
	g_slice_free (TerminalTerminalSpawnOnFlatpakData, _data_);
#line 2740 "Terminal.c"
}

static gpointer
_g_array_ref0 (gpointer self)
{
#line 21 "../src/widgets/Terminal.vala"
	return self ? g_array_ref (self) : NULL;
#line 2748 "Terminal.c"
}

static void
terminal_terminal_spawn_on_flatpak (TerminalTerminal* self,
                                    VtePtyFlags flags,
                                    const gchar* cwd,
                                    GArray* argv,
                                    GArray* envv,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	TerminalTerminalSpawnOnFlatpakData* _data_;
	TerminalTerminal* _tmp0_;
	gchar* _tmp1_;
	GArray* _tmp2_;
	GArray* _tmp3_;
#line 21 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/widgets/Terminal.vala"
	g_return_if_fail (argv != NULL);
#line 21 "../src/widgets/Terminal.vala"
	g_return_if_fail (envv != NULL);
#line 21 "../src/widgets/Terminal.vala"
	_data_ = g_slice_new0 (TerminalTerminalSpawnOnFlatpakData);
#line 21 "../src/widgets/Terminal.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 21 "../src/widgets/Terminal.vala"
	g_task_set_task_data (_data_->_async_result, _data_, terminal_terminal_spawn_on_flatpak_data_free);
#line 21 "../src/widgets/Terminal.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "../src/widgets/Terminal.vala"
	_data_->self = _tmp0_;
#line 21 "../src/widgets/Terminal.vala"
	_data_->flags = flags;
#line 21 "../src/widgets/Terminal.vala"
	_tmp1_ = g_strdup (cwd);
#line 21 "../src/widgets/Terminal.vala"
	_g_free0 (_data_->cwd);
#line 21 "../src/widgets/Terminal.vala"
	_data_->cwd = _tmp1_;
#line 21 "../src/widgets/Terminal.vala"
	_tmp2_ = _g_array_ref0 (argv);
#line 21 "../src/widgets/Terminal.vala"
	_g_array_unref0 (_data_->argv);
#line 21 "../src/widgets/Terminal.vala"
	_data_->argv = _tmp2_;
#line 21 "../src/widgets/Terminal.vala"
	_tmp3_ = _g_array_ref0 (envv);
#line 21 "../src/widgets/Terminal.vala"
	_g_array_unref0 (_data_->envv);
#line 21 "../src/widgets/Terminal.vala"
	_data_->envv = _tmp3_;
#line 21 "../src/widgets/Terminal.vala"
	terminal_terminal_spawn_on_flatpak_co (_data_);
#line 2803 "Terminal.c"
}

static gboolean
terminal_terminal_spawn_on_flatpak_finish (TerminalTerminal* self,
                                           GAsyncResult* _res_,
                                           GPid* p,
                                           GError** error)
{
	gboolean result;
	TerminalTerminalSpawnOnFlatpakData* _data_;
#line 21 "../src/widgets/Terminal.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 21 "../src/widgets/Terminal.vala"
	if (NULL == _data_) {
#line 2818 "Terminal.c"
		gboolean _tmp0_ = FALSE;
#line 21 "../src/widgets/Terminal.vala"
		return _tmp0_;
#line 2822 "Terminal.c"
	}
#line 21 "../src/widgets/Terminal.vala"
	if (p) {
#line 21 "../src/widgets/Terminal.vala"
		*p = _data_->p;
#line 2828 "Terminal.c"
	}
#line 21 "../src/widgets/Terminal.vala"
	result = _data_->result;
#line 21 "../src/widgets/Terminal.vala"
	return result;
#line 2834 "Terminal.c"
}

static void
_vala_array_add3 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 588 "../src/widgets/Terminal.vala"
	if ((*length) == (*size)) {
#line 588 "../src/widgets/Terminal.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 588 "../src/widgets/Terminal.vala"
		*array = g_renew (gint, *array, *size);
#line 2849 "Terminal.c"
	}
#line 588 "../src/widgets/Terminal.vala"
	(*array)[(*length)++] = value;
#line 2853 "Terminal.c"
}

static void
_vala_array_add4 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 595 "../src/widgets/Terminal.vala"
	if ((*length) == (*size)) {
#line 595 "../src/widgets/Terminal.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 595 "../src/widgets/Terminal.vala"
		*array = g_renew (gint, *array, *size);
#line 2868 "Terminal.c"
	}
#line 595 "../src/widgets/Terminal.vala"
	(*array)[(*length)++] = value;
#line 2872 "Terminal.c"
}

static void
_vala_array_add5 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 596 "../src/widgets/Terminal.vala"
	if ((*length) == (*size)) {
#line 596 "../src/widgets/Terminal.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 596 "../src/widgets/Terminal.vala"
		*array = g_renew (gint, *array, *size);
#line 2887 "Terminal.c"
	}
#line 596 "../src/widgets/Terminal.vala"
	(*array)[(*length)++] = value;
#line 2891 "Terminal.c"
}

static void
_terminal_terminal_on_host_command_exited_terminal_host_command_exited_callback (guint pid,
                                                                                 guint status,
                                                                                 gpointer self)
{
#line 600 "../src/widgets/Terminal.vala"
	terminal_terminal_on_host_command_exited ((TerminalTerminal*) self, pid, status);
#line 2901 "Terminal.c"
}

static void
terminal_terminal_spawn_on_flatpak_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	TerminalTerminalSpawnOnFlatpakData* _data_;
#line 600 "../src/widgets/Terminal.vala"
	_data_ = _user_data_;
#line 600 "../src/widgets/Terminal.vala"
	_data_->_source_object_ = source_object;
#line 600 "../src/widgets/Terminal.vala"
	_data_->_res_ = _res_;
#line 600 "../src/widgets/Terminal.vala"
	terminal_terminal_spawn_on_flatpak_co (_data_);
#line 2918 "Terminal.c"
}

static gboolean
terminal_terminal_spawn_on_flatpak_co (TerminalTerminalSpawnOnFlatpakData* _data_)
{
#line 557 "../src/widgets/Terminal.vala"
	switch (_data_->_state_) {
#line 557 "../src/widgets/Terminal.vala"
		case 0:
#line 2928 "Terminal.c"
		goto _state_0;
#line 557 "../src/widgets/Terminal.vala"
		case 1:
#line 2932 "Terminal.c"
		goto _state_1;
		default:
#line 557 "../src/widgets/Terminal.vala"
		g_assert_not_reached ();
#line 2937 "Terminal.c"
	}
	_state_0:
#line 563 "../src/widgets/Terminal.vala"
	_data_->p = (GPid) -1;
#line 2942 "Terminal.c"
	{
#line 567 "../src/widgets/Terminal.vala"
		_data_->_tmp1_ = vte_pty_new_sync (_data_->flags, NULL, &_data_->_inner_error0_);
#line 567 "../src/widgets/Terminal.vala"
		_data_->_tmp0_ = _data_->_tmp1_;
#line 567 "../src/widgets/Terminal.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2950 "Terminal.c"
			goto __catch0_g_error;
		}
#line 567 "../src/widgets/Terminal.vala"
		_data_->_tmp2_ = _data_->_tmp0_;
#line 567 "../src/widgets/Terminal.vala"
		_data_->_tmp0_ = NULL;
#line 567 "../src/widgets/Terminal.vala"
		_g_object_unref0 (_data_->_ppty);
#line 567 "../src/widgets/Terminal.vala"
		_data_->_ppty = _data_->_tmp2_;
#line 566 "../src/widgets/Terminal.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 2963 "Terminal.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 566 "../src/widgets/Terminal.vala"
		_data_->e = _data_->_inner_error0_;
#line 566 "../src/widgets/Terminal.vala"
		_data_->_inner_error0_ = NULL;
#line 570 "../src/widgets/Terminal.vala"
		_data_->_tmp3_ = _data_->e;
#line 570 "../src/widgets/Terminal.vala"
		_data_->_tmp4_ = _data_->_tmp3_->message;
#line 570 "../src/widgets/Terminal.vala"
		g_warning ("Terminal.vala:570: %s", _data_->_tmp4_);
#line 571 "../src/widgets/Terminal.vala"
		_data_->result = FALSE;
#line 571 "../src/widgets/Terminal.vala"
		_g_error_free0 (_data_->e);
#line 571 "../src/widgets/Terminal.vala"
		_g_object_unref0 (_data_->_ppty);
#line 571 "../src/widgets/Terminal.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 571 "../src/widgets/Terminal.vala"
		if (_data_->_state_ != 0) {
#line 571 "../src/widgets/Terminal.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 571 "../src/widgets/Terminal.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2992 "Terminal.c"
			}
		}
#line 571 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 571 "../src/widgets/Terminal.vala"
		return FALSE;
#line 2999 "Terminal.c"
	}
	__finally0:
#line 566 "../src/widgets/Terminal.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 566 "../src/widgets/Terminal.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 566 "../src/widgets/Terminal.vala"
		_g_object_unref0 (_data_->_ppty);
#line 566 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 566 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3012 "Terminal.c"
	}
#line 574 "../src/widgets/Terminal.vala"
	_data_->_tmp5_ = _data_->_ppty;
#line 574 "../src/widgets/Terminal.vala"
	_data_->pty_master = vte_pty_get_fd (_data_->_tmp5_);
#line 576 "../src/widgets/Terminal.vala"
	if (grantpt (_data_->pty_master) != 0) {
#line 577 "../src/widgets/Terminal.vala"
		g_warning ("Terminal.vala:577: Failed granting access to slave pseudoterminal devi" \
"ce");
#line 578 "../src/widgets/Terminal.vala"
		_data_->result = FALSE;
#line 578 "../src/widgets/Terminal.vala"
		_g_object_unref0 (_data_->_ppty);
#line 578 "../src/widgets/Terminal.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 578 "../src/widgets/Terminal.vala"
		if (_data_->_state_ != 0) {
#line 578 "../src/widgets/Terminal.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 578 "../src/widgets/Terminal.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3034 "Terminal.c"
			}
		}
#line 578 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 578 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3041 "Terminal.c"
	}
#line 581 "../src/widgets/Terminal.vala"
	if (unlockpt (_data_->pty_master) != 0) {
#line 582 "../src/widgets/Terminal.vala"
		g_warning ("Terminal.vala:582: Failed unlocking slave pseudoterminal device");
#line 583 "../src/widgets/Terminal.vala"
		_data_->result = FALSE;
#line 583 "../src/widgets/Terminal.vala"
		_g_object_unref0 (_data_->_ppty);
#line 583 "../src/widgets/Terminal.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 583 "../src/widgets/Terminal.vala"
		if (_data_->_state_ != 0) {
#line 583 "../src/widgets/Terminal.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 583 "../src/widgets/Terminal.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3059 "Terminal.c"
			}
		}
#line 583 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 583 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3066 "Terminal.c"
	}
#line 586 "../src/widgets/Terminal.vala"
	_data_->_tmp6_ = g_new0 (gint, 0);
#line 586 "../src/widgets/Terminal.vala"
	_data_->pty_slaves = _data_->_tmp6_;
#line 586 "../src/widgets/Terminal.vala"
	_data_->pty_slaves_length1 = 0;
#line 586 "../src/widgets/Terminal.vala"
	_data_->_pty_slaves_size_ = _data_->pty_slaves_length1;
#line 588 "../src/widgets/Terminal.vala"
	_data_->_tmp7_ = ptsname (_data_->pty_master);
#line 588 "../src/widgets/Terminal.vala"
	_vala_array_add3 (&_data_->pty_slaves, &_data_->pty_slaves_length1, &_data_->_pty_slaves_size_, open (_data_->_tmp7_, O_RDWR | O_CLOEXEC, (mode_t) 0));
#line 590 "../src/widgets/Terminal.vala"
	_data_->_tmp8_ = _data_->pty_slaves;
#line 590 "../src/widgets/Terminal.vala"
	_data_->_tmp8__length1 = _data_->pty_slaves_length1;
#line 590 "../src/widgets/Terminal.vala"
	_data_->_tmp9_ = _data_->_tmp8_[0];
#line 590 "../src/widgets/Terminal.vala"
	if (_data_->_tmp9_ < 0) {
#line 591 "../src/widgets/Terminal.vala"
		g_warning ("Terminal.vala:591: Failed opening slave pseudoterminal device");
#line 592 "../src/widgets/Terminal.vala"
		_data_->result = FALSE;
#line 592 "../src/widgets/Terminal.vala"
		_data_->pty_slaves = (g_free (_data_->pty_slaves), NULL);
#line 592 "../src/widgets/Terminal.vala"
		_g_object_unref0 (_data_->_ppty);
#line 592 "../src/widgets/Terminal.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 592 "../src/widgets/Terminal.vala"
		if (_data_->_state_ != 0) {
#line 592 "../src/widgets/Terminal.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 592 "../src/widgets/Terminal.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3104 "Terminal.c"
			}
		}
#line 592 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 592 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3111 "Terminal.c"
	}
#line 595 "../src/widgets/Terminal.vala"
	_data_->_tmp10_ = _data_->pty_slaves;
#line 595 "../src/widgets/Terminal.vala"
	_data_->_tmp10__length1 = _data_->pty_slaves_length1;
#line 595 "../src/widgets/Terminal.vala"
	_data_->_tmp11_ = _data_->_tmp10_[0];
#line 595 "../src/widgets/Terminal.vala"
	_vala_array_add4 (&_data_->pty_slaves, &_data_->pty_slaves_length1, &_data_->_pty_slaves_size_, dup (_data_->_tmp11_));
#line 596 "../src/widgets/Terminal.vala"
	_data_->_tmp12_ = _data_->pty_slaves;
#line 596 "../src/widgets/Terminal.vala"
	_data_->_tmp12__length1 = _data_->pty_slaves_length1;
#line 596 "../src/widgets/Terminal.vala"
	_data_->_tmp13_ = _data_->_tmp12_[0];
#line 596 "../src/widgets/Terminal.vala"
	_vala_array_add5 (&_data_->pty_slaves, &_data_->pty_slaves_length1, &_data_->_pty_slaves_size_, dup (_data_->_tmp13_));
#line 598 "../src/widgets/Terminal.vala"
	_data_->_tmp14_ = g_cancellable_new ();
#line 598 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_data_->self->priv->fp_spawn_host_command_callback_cancellable);
#line 598 "../src/widgets/Terminal.vala"
	_data_->self->priv->fp_spawn_host_command_callback_cancellable = _data_->_tmp14_;
#line 600 "../src/widgets/Terminal.vala"
	_data_->_tmp15_ = _data_->pty_slaves;
#line 600 "../src/widgets/Terminal.vala"
	_data_->_tmp15__length1 = _data_->pty_slaves_length1;
#line 600 "../src/widgets/Terminal.vala"
	_data_->_tmp16_ = _data_->self->priv->fp_spawn_host_command_callback_cancellable;
#line 600 "../src/widgets/Terminal.vala"
	_data_->_tmp17_ = 0;
#line 600 "../src/widgets/Terminal.vala"
	_data_->_state_ = 1;
#line 600 "../src/widgets/Terminal.vala"
	terminal_send_host_command (_data_->cwd, _data_->argv, _data_->envv, _data_->_tmp15_, (gint) _data_->_tmp15__length1, _terminal_terminal_on_host_command_exited_terminal_host_command_exited_callback, _data_->self, _data_->_tmp16_, terminal_terminal_spawn_on_flatpak_ready, _data_);
#line 600 "../src/widgets/Terminal.vala"
	return FALSE;
#line 3149 "Terminal.c"
	_state_1:
#line 600 "../src/widgets/Terminal.vala"
	_data_->_tmp18_ = terminal_send_host_command_finish (_data_->_res_, &_data_->_tmp17_, &_data_->_inner_error0_);
#line 600 "../src/widgets/Terminal.vala"
	_data_->p = (GPid) _data_->_tmp17_;
#line 600 "../src/widgets/Terminal.vala"
	_data_->res = _data_->_tmp18_;
#line 600 "../src/widgets/Terminal.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 600 "../src/widgets/Terminal.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 600 "../src/widgets/Terminal.vala"
		_data_->pty_slaves = (g_free (_data_->pty_slaves), NULL);
#line 600 "../src/widgets/Terminal.vala"
		_g_object_unref0 (_data_->_ppty);
#line 600 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 600 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3169 "Terminal.c"
	}
#line 610 "../src/widgets/Terminal.vala"
	_data_->_tmp19_ = _data_->_ppty;
#line 610 "../src/widgets/Terminal.vala"
	vte_terminal_set_pty ((VteTerminal*) _data_->self, _data_->_tmp19_);
#line 612 "../src/widgets/Terminal.vala"
	_data_->result = _data_->res;
#line 612 "../src/widgets/Terminal.vala"
	_data_->pty_slaves = (g_free (_data_->pty_slaves), NULL);
#line 612 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_data_->_ppty);
#line 612 "../src/widgets/Terminal.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 612 "../src/widgets/Terminal.vala"
	if (_data_->_state_ != 0) {
#line 612 "../src/widgets/Terminal.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 612 "../src/widgets/Terminal.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3189 "Terminal.c"
		}
	}
#line 612 "../src/widgets/Terminal.vala"
	g_object_unref (_data_->_async_result);
#line 612 "../src/widgets/Terminal.vala"
	return FALSE;
#line 3196 "Terminal.c"
}

static void
terminal_terminal_on_host_command_exited (TerminalTerminal* self,
                                          guint _pid,
                                          guint status)
{
#line 615 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 616 "../src/widgets/Terminal.vala"
	g_signal_emit_by_name ((VteTerminal*) self, "child-exited", (gint) status);
#line 3208 "Terminal.c"
}

static void
terminal_terminal_send_command_completed_notification (TerminalTerminal* self)
{
	gboolean desktop_notifications_enabled = FALSE;
	TerminalSettings* _tmp0_;
	TerminalSettings* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 619 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 620 "../src/widgets/Terminal.vala"
	_tmp0_ = terminal_settings_get_default ();
#line 620 "../src/widgets/Terminal.vala"
	_tmp1_ = _tmp0_;
#line 620 "../src/widgets/Terminal.vala"
	_tmp2_ = terminal_settings_get_notify_process_completion (_tmp1_);
#line 620 "../src/widgets/Terminal.vala"
	_tmp3_ = _tmp2_;
#line 620 "../src/widgets/Terminal.vala"
	_tmp4_ = _tmp3_;
#line 620 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_tmp1_);
#line 620 "../src/widgets/Terminal.vala"
	desktop_notifications_enabled = _tmp4_;
#line 623 "../src/widgets/Terminal.vala"
	if (desktop_notifications_enabled) {
#line 3238 "Terminal.c"
		GNotification* n = NULL;
		GNotification* _tmp5_;
		GNotification* _tmp6_;
		TerminalProcess* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		GNotification* _tmp10_;
		TerminalWindow* _tmp11_;
		guint _tmp12_;
		guint _tmp13_;
		guint _tmp14_;
		TerminalWindow* _tmp15_;
		GtkApplication* _tmp16_;
		GtkApplication* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		GNotification* _tmp20_;
#line 624 "../src/widgets/Terminal.vala"
		_tmp5_ = g_notification_new (_ ("Command completed"));
#line 624 "../src/widgets/Terminal.vala"
		n = _tmp5_;
#line 625 "../src/widgets/Terminal.vala"
		_tmp6_ = n;
#line 625 "../src/widgets/Terminal.vala"
		_tmp7_ = self->priv->_process;
#line 625 "../src/widgets/Terminal.vala"
		_tmp8_ = terminal_process_get_last_foreground_task_command (_tmp7_);
#line 625 "../src/widgets/Terminal.vala"
		_tmp9_ = _tmp8_;
#line 625 "../src/widgets/Terminal.vala"
		g_notification_set_body (_tmp6_, _tmp9_);
#line 626 "../src/widgets/Terminal.vala"
		_tmp10_ = n;
#line 626 "../src/widgets/Terminal.vala"
		_tmp11_ = self->window;
#line 626 "../src/widgets/Terminal.vala"
		_tmp12_ = terminal_window_get_id (_tmp11_);
#line 626 "../src/widgets/Terminal.vala"
		_tmp13_ = _tmp12_;
#line 626 "../src/widgets/Terminal.vala"
		_tmp14_ = self->priv->_id;
#line 626 "../src/widgets/Terminal.vala"
		g_notification_set_default_action_and_target (_tmp10_, "app.focus-tab", "(uu)", _tmp13_, _tmp14_, NULL);
#line 630 "../src/widgets/Terminal.vala"
		_tmp15_ = self->window;
#line 630 "../src/widgets/Terminal.vala"
		_tmp16_ = gtk_window_get_application ((GtkWindow*) _tmp15_);
#line 630 "../src/widgets/Terminal.vala"
		_tmp17_ = _tmp16_;
#line 630 "../src/widgets/Terminal.vala"
		_tmp18_ = terminal_terminal_process_completed_notification_id (self);
#line 630 "../src/widgets/Terminal.vala"
		_tmp19_ = _tmp18_;
#line 630 "../src/widgets/Terminal.vala"
		_tmp20_ = n;
#line 630 "../src/widgets/Terminal.vala"
		g_application_send_notification ((GApplication*) _tmp17_, _tmp19_, _tmp20_);
#line 630 "../src/widgets/Terminal.vala"
		_g_free0 (_tmp19_);
#line 623 "../src/widgets/Terminal.vala"
		_g_object_unref0 (n);
#line 3300 "Terminal.c"
	}
}

static void
terminal_terminal_withdraw_command_completed_notification (TerminalTerminal* self)
{
	TerminalWindow* _tmp0_;
	GtkApplication* _tmp1_;
	GtkApplication* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 637 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 638 "../src/widgets/Terminal.vala"
	_tmp0_ = self->window;
#line 638 "../src/widgets/Terminal.vala"
	_tmp1_ = gtk_window_get_application ((GtkWindow*) _tmp0_);
#line 638 "../src/widgets/Terminal.vala"
	_tmp2_ = _tmp1_;
#line 638 "../src/widgets/Terminal.vala"
	_tmp3_ = terminal_terminal_process_completed_notification_id (self);
#line 638 "../src/widgets/Terminal.vala"
	_tmp4_ = _tmp3_;
#line 638 "../src/widgets/Terminal.vala"
	g_application_withdraw_notification ((GApplication*) _tmp2_, _tmp4_);
#line 638 "../src/widgets/Terminal.vala"
	_g_free0 (_tmp4_);
#line 3328 "Terminal.c"
}

static void
terminal_terminal_on_child_exited (TerminalTerminal* self,
                                   gint status)
{
#line 645 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 646 "../src/widgets/Terminal.vala"
	g_debug ("Terminal.vala:646: Child exited with code %d", status);
#line 647 "../src/widgets/Terminal.vala"
	terminal_terminal_set_pid (self, (GPid) -1);
#line 651 "../src/widgets/Terminal.vala"
	terminal_terminal_set_process (self, NULL);
#line 652 "../src/widgets/Terminal.vala"
	g_signal_emit (self, terminal_terminal_signals[TERMINAL_TERMINAL_EXIT_SIGNAL], 0);
#line 3345 "Terminal.c"
}

static gboolean
terminal_terminal_on_key_pressed (TerminalTerminal* self,
                                  guint keyval,
                                  guint keycode,
                                  GdkModifierType state)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 664 "../src/widgets/Terminal.vala"
	static GQuark _tmp2_label0 = 0;
#line 664 "../src/widgets/Terminal.vala"
	static GQuark _tmp2_label1 = 0;
#line 3361 "Terminal.c"
	gboolean result;
#line 655 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 660 "../src/widgets/Terminal.vala"
	if ((state & GDK_CONTROL_MASK) == 0) {
#line 661 "../src/widgets/Terminal.vala"
		result = FALSE;
#line 661 "../src/widgets/Terminal.vala"
		return result;
#line 3371 "Terminal.c"
	}
#line 664 "../src/widgets/Terminal.vala"
	_tmp0_ = gdk_keyval_name (keyval);
#line 664 "../src/widgets/Terminal.vala"
	_tmp1_ = _tmp0_;
#line 664 "../src/widgets/Terminal.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 664 "../src/widgets/Terminal.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("c")))) {
#line 664 "../src/widgets/Terminal.vala"
		switch (0) {
#line 3383 "Terminal.c"
			default:
			{
				{
					gboolean _tmp4_ = FALSE;
#line 667 "../src/widgets/Terminal.vala"
					if (vte_terminal_get_has_selection ((VteTerminal*) self)) {
#line 3390 "Terminal.c"
						TerminalSettings* _tmp5_;
						TerminalSettings* _tmp6_;
						gboolean _tmp7_;
						gboolean _tmp8_;
#line 668 "../src/widgets/Terminal.vala"
						_tmp5_ = terminal_settings_get_default ();
#line 668 "../src/widgets/Terminal.vala"
						_tmp6_ = _tmp5_;
#line 668 "../src/widgets/Terminal.vala"
						_tmp7_ = terminal_settings_get_easy_copy_paste (_tmp6_);
#line 668 "../src/widgets/Terminal.vala"
						_tmp8_ = _tmp7_;
#line 668 "../src/widgets/Terminal.vala"
						_tmp4_ = _tmp8_;
#line 668 "../src/widgets/Terminal.vala"
						_g_object_unref0 (_tmp6_);
#line 3407 "Terminal.c"
					} else {
#line 667 "../src/widgets/Terminal.vala"
						_tmp4_ = FALSE;
#line 3411 "Terminal.c"
					}
#line 666 "../src/widgets/Terminal.vala"
					if (_tmp4_) {
#line 670 "../src/widgets/Terminal.vala"
						terminal_terminal_do_copy_clipboard (self);
#line 671 "../src/widgets/Terminal.vala"
						vte_terminal_unselect_all ((VteTerminal*) self);
#line 672 "../src/widgets/Terminal.vala"
						result = TRUE;
#line 672 "../src/widgets/Terminal.vala"
						return result;
#line 3423 "Terminal.c"
					}
#line 674 "../src/widgets/Terminal.vala"
					result = FALSE;
#line 674 "../src/widgets/Terminal.vala"
					return result;
#line 3429 "Terminal.c"
				}
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("v")))) {
#line 664 "../src/widgets/Terminal.vala"
		switch (0) {
#line 3436 "Terminal.c"
			default:
			{
				{
					TerminalSettings* _tmp9_;
					TerminalSettings* _tmp10_;
					gboolean _tmp11_;
					gboolean _tmp12_;
					gboolean _tmp13_;
#line 677 "../src/widgets/Terminal.vala"
					_tmp9_ = terminal_settings_get_default ();
#line 677 "../src/widgets/Terminal.vala"
					_tmp10_ = _tmp9_;
#line 677 "../src/widgets/Terminal.vala"
					_tmp11_ = terminal_settings_get_easy_copy_paste (_tmp10_);
#line 677 "../src/widgets/Terminal.vala"
					_tmp12_ = _tmp11_;
#line 677 "../src/widgets/Terminal.vala"
					_tmp13_ = _tmp12_;
#line 677 "../src/widgets/Terminal.vala"
					_g_object_unref0 (_tmp10_);
#line 677 "../src/widgets/Terminal.vala"
					if (_tmp13_) {
#line 678 "../src/widgets/Terminal.vala"
						terminal_terminal_do_paste_clipboard (self);
#line 679 "../src/widgets/Terminal.vala"
						result = TRUE;
#line 679 "../src/widgets/Terminal.vala"
						return result;
#line 3465 "Terminal.c"
					}
#line 681 "../src/widgets/Terminal.vala"
					result = FALSE;
#line 681 "../src/widgets/Terminal.vala"
					return result;
#line 3471 "Terminal.c"
				}
			}
		}
	}
#line 685 "../src/widgets/Terminal.vala"
	result = FALSE;
#line 685 "../src/widgets/Terminal.vala"
	return result;
#line 3480 "Terminal.c"
}

static void
terminal_terminal_get_can_close_data_free (gpointer _data)
{
	TerminalTerminalGetCanCloseData* _data_;
	_data_ = _data;
#line 21 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_data_->self);
#line 21 "../src/widgets/Terminal.vala"
	g_slice_free (TerminalTerminalGetCanCloseData, _data_);
#line 3492 "Terminal.c"
}

void
terminal_terminal_get_can_close (TerminalTerminal* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	TerminalTerminalGetCanCloseData* _data_;
	TerminalTerminal* _tmp0_;
#line 21 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/widgets/Terminal.vala"
	_data_ = g_slice_new0 (TerminalTerminalGetCanCloseData);
#line 21 "../src/widgets/Terminal.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 21 "../src/widgets/Terminal.vala"
	g_task_set_task_data (_data_->_async_result, _data_, terminal_terminal_get_can_close_data_free);
#line 21 "../src/widgets/Terminal.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "../src/widgets/Terminal.vala"
	_data_->self = _tmp0_;
#line 21 "../src/widgets/Terminal.vala"
	terminal_terminal_get_can_close_co (_data_);
#line 3516 "Terminal.c"
}

gboolean
terminal_terminal_get_can_close_finish (TerminalTerminal* self,
                                        GAsyncResult* _res_,
                                        gchar** command)
{
	gboolean result;
	TerminalTerminalGetCanCloseData* _data_;
#line 21 "../src/widgets/Terminal.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 21 "../src/widgets/Terminal.vala"
	if (command) {
#line 21 "../src/widgets/Terminal.vala"
		*command = _data_->command;
#line 3532 "Terminal.c"
	} else {
#line 21 "../src/widgets/Terminal.vala"
		_g_free0 (_data_->command);
#line 3536 "Terminal.c"
	}
#line 21 "../src/widgets/Terminal.vala"
	_data_->command = NULL;
#line 21 "../src/widgets/Terminal.vala"
	result = _data_->result;
#line 21 "../src/widgets/Terminal.vala"
	return result;
#line 3544 "Terminal.c"
}

static void
terminal_terminal_get_can_close_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	TerminalTerminalGetCanCloseData* _data_;
#line 701 "../src/widgets/Terminal.vala"
	_data_ = _user_data_;
#line 701 "../src/widgets/Terminal.vala"
	_data_->_source_object_ = source_object;
#line 701 "../src/widgets/Terminal.vala"
	_data_->_res_ = _res_;
#line 701 "../src/widgets/Terminal.vala"
	terminal_terminal_get_can_close_co (_data_);
#line 3561 "Terminal.c"
}

static gboolean
terminal_terminal_get_can_close_co (TerminalTerminalGetCanCloseData* _data_)
{
#line 688 "../src/widgets/Terminal.vala"
	switch (_data_->_state_) {
#line 688 "../src/widgets/Terminal.vala"
		case 0:
#line 3571 "Terminal.c"
		goto _state_0;
#line 688 "../src/widgets/Terminal.vala"
		case 1:
#line 3575 "Terminal.c"
		goto _state_1;
		default:
#line 688 "../src/widgets/Terminal.vala"
		g_assert_not_reached ();
#line 3580 "Terminal.c"
	}
	_state_0:
#line 689 "../src/widgets/Terminal.vala"
	_g_free0 (_data_->command);
#line 689 "../src/widgets/Terminal.vala"
	_data_->command = NULL;
#line 691 "../src/widgets/Terminal.vala"
	_data_->_tmp1_ = _data_->self->priv->_pid;
#line 691 "../src/widgets/Terminal.vala"
	if (_data_->_tmp1_ < ((GPid) 0)) {
#line 691 "../src/widgets/Terminal.vala"
		_data_->_tmp0_ = TRUE;
#line 3593 "Terminal.c"
	} else {
#line 691 "../src/widgets/Terminal.vala"
		_data_->_tmp2_ = vte_terminal_get_pty ((VteTerminal*) _data_->self);
#line 691 "../src/widgets/Terminal.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 691 "../src/widgets/Terminal.vala"
		_data_->_tmp0_ = _data_->_tmp3_ == NULL;
#line 3601 "Terminal.c"
	}
#line 691 "../src/widgets/Terminal.vala"
	if (_data_->_tmp0_) {
#line 692 "../src/widgets/Terminal.vala"
		_data_->result = TRUE;
#line 692 "../src/widgets/Terminal.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 692 "../src/widgets/Terminal.vala"
		if (_data_->_state_ != 0) {
#line 692 "../src/widgets/Terminal.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 692 "../src/widgets/Terminal.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3615 "Terminal.c"
			}
		}
#line 692 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 692 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3622 "Terminal.c"
	}
#line 695 "../src/widgets/Terminal.vala"
	_data_->_tmp4_ = vte_terminal_get_pty ((VteTerminal*) _data_->self);
#line 695 "../src/widgets/Terminal.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 695 "../src/widgets/Terminal.vala"
	_data_->_tmp6_ = vte_pty_get_fd (_data_->_tmp5_);
#line 695 "../src/widgets/Terminal.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 695 "../src/widgets/Terminal.vala"
	_data_->fd = _data_->_tmp7_;
#line 696 "../src/widgets/Terminal.vala"
	if (_data_->fd == -1) {
#line 697 "../src/widgets/Terminal.vala"
		_data_->result = TRUE;
#line 697 "../src/widgets/Terminal.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 697 "../src/widgets/Terminal.vala"
		if (_data_->_state_ != 0) {
#line 697 "../src/widgets/Terminal.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 697 "../src/widgets/Terminal.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3646 "Terminal.c"
			}
		}
#line 697 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 697 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3653 "Terminal.c"
	}
#line 701 "../src/widgets/Terminal.vala"
	_data_->_state_ = 1;
#line 701 "../src/widgets/Terminal.vala"
	terminal_get_foreground_process (_data_->fd, NULL, terminal_terminal_get_can_close_ready, _data_);
#line 701 "../src/widgets/Terminal.vala"
	return FALSE;
#line 3661 "Terminal.c"
	_state_1:
#line 701 "../src/widgets/Terminal.vala"
	_data_->fgpid = terminal_get_foreground_process_finish (_data_->_res_);
#line 702 "../src/widgets/Terminal.vala"
	if (_data_->fgpid == -1) {
#line 703 "../src/widgets/Terminal.vala"
		_data_->result = FALSE;
#line 703 "../src/widgets/Terminal.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 703 "../src/widgets/Terminal.vala"
		if (_data_->_state_ != 0) {
#line 703 "../src/widgets/Terminal.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 703 "../src/widgets/Terminal.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3677 "Terminal.c"
			}
		}
#line 703 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 703 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3684 "Terminal.c"
	}
#line 706 "../src/widgets/Terminal.vala"
	_data_->_tmp8_ = _data_->self->priv->_pid;
#line 706 "../src/widgets/Terminal.vala"
	if (_data_->fgpid == ((gint) _data_->_tmp8_)) {
#line 707 "../src/widgets/Terminal.vala"
		_data_->result = TRUE;
#line 707 "../src/widgets/Terminal.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 707 "../src/widgets/Terminal.vala"
		if (_data_->_state_ != 0) {
#line 707 "../src/widgets/Terminal.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 707 "../src/widgets/Terminal.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3700 "Terminal.c"
			}
		}
#line 707 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 707 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3707 "Terminal.c"
	}
#line 710 "../src/widgets/Terminal.vala"
	_data_->_tmp9_ = terminal_get_process_cmdline (_data_->fgpid);
#line 710 "../src/widgets/Terminal.vala"
	_g_free0 (_data_->command);
#line 710 "../src/widgets/Terminal.vala"
	_data_->command = _data_->_tmp9_;
#line 712 "../src/widgets/Terminal.vala"
	_data_->_tmp10_ = _data_->command;
#line 712 "../src/widgets/Terminal.vala"
	_data_->result = _data_->_tmp10_ == NULL;
#line 712 "../src/widgets/Terminal.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 712 "../src/widgets/Terminal.vala"
	if (_data_->_state_ != 0) {
#line 712 "../src/widgets/Terminal.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 712 "../src/widgets/Terminal.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3727 "Terminal.c"
		}
	}
#line 712 "../src/widgets/Terminal.vala"
	g_object_unref (_data_->_async_result);
#line 712 "../src/widgets/Terminal.vala"
	return FALSE;
#line 3734 "Terminal.c"
}

void
terminal_terminal_zoom_in (TerminalTerminal* self)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 715 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 716 "../src/widgets/Terminal.vala"
	_tmp0_ = vte_terminal_get_font_scale ((VteTerminal*) self);
#line 716 "../src/widgets/Terminal.vala"
	_tmp1_ = _tmp0_;
#line 716 "../src/widgets/Terminal.vala"
	vte_terminal_set_font_scale ((VteTerminal*) self, MIN ((gdouble) 10, _tmp1_ + 0.1));
#line 3750 "Terminal.c"
}

void
terminal_terminal_zoom_out (TerminalTerminal* self)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 719 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 720 "../src/widgets/Terminal.vala"
	_tmp0_ = vte_terminal_get_font_scale ((VteTerminal*) self);
#line 720 "../src/widgets/Terminal.vala"
	_tmp1_ = _tmp0_;
#line 720 "../src/widgets/Terminal.vala"
	vte_terminal_set_font_scale ((VteTerminal*) self, MAX (0.1, _tmp1_ - 0.1));
#line 3766 "Terminal.c"
}

void
terminal_terminal_zoom_default (TerminalTerminal* self)
{
#line 723 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 724 "../src/widgets/Terminal.vala"
	vte_terminal_set_font_scale ((VteTerminal*) self, 1.0);
#line 3776 "Terminal.c"
}

void
terminal_terminal_do_paste_clipboard (TerminalTerminal* self)
{
#line 727 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 728 "../src/widgets/Terminal.vala"
	vte_terminal_paste_clipboard ((VteTerminal*) self);
#line 3786 "Terminal.c"
}

void
terminal_terminal_do_copy_clipboard (TerminalTerminal* self)
{
#line 731 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 732 "../src/widgets/Terminal.vala"
	vte_terminal_copy_clipboard ((VteTerminal*) self);
#line 3796 "Terminal.c"
}

static void
terminal_terminal_do_paste_from_selection_clipboard_data_free (gpointer _data)
{
	TerminalTerminalDoPasteFromSelectionClipboardData* _data_;
	_data_ = _data;
#line 21 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_data_->self);
#line 21 "../src/widgets/Terminal.vala"
	g_slice_free (TerminalTerminalDoPasteFromSelectionClipboardData, _data_);
#line 3808 "Terminal.c"
}

void
terminal_terminal_do_paste_from_selection_clipboard (TerminalTerminal* self,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	TerminalTerminalDoPasteFromSelectionClipboardData* _data_;
	TerminalTerminal* _tmp0_;
#line 21 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/widgets/Terminal.vala"
	_data_ = g_slice_new0 (TerminalTerminalDoPasteFromSelectionClipboardData);
#line 21 "../src/widgets/Terminal.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 21 "../src/widgets/Terminal.vala"
	g_task_set_task_data (_data_->_async_result, _data_, terminal_terminal_do_paste_from_selection_clipboard_data_free);
#line 21 "../src/widgets/Terminal.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "../src/widgets/Terminal.vala"
	_data_->self = _tmp0_;
#line 21 "../src/widgets/Terminal.vala"
	terminal_terminal_do_paste_from_selection_clipboard_co (_data_);
#line 3832 "Terminal.c"
}

void
terminal_terminal_do_paste_from_selection_clipboard_finish (TerminalTerminal* self,
                                                            GAsyncResult* _res_)
{
	TerminalTerminalDoPasteFromSelectionClipboardData* _data_;
#line 21 "../src/widgets/Terminal.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3842 "Terminal.c"
}

static void
terminal_terminal_do_paste_from_selection_clipboard_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_)
{
	TerminalTerminalDoPasteFromSelectionClipboardData* _data_;
#line 741 "../src/widgets/Terminal.vala"
	_data_ = _user_data_;
#line 741 "../src/widgets/Terminal.vala"
	_data_->_source_object_ = source_object;
#line 741 "../src/widgets/Terminal.vala"
	_data_->_res_ = _res_;
#line 741 "../src/widgets/Terminal.vala"
	terminal_terminal_do_paste_from_selection_clipboard_co (_data_);
#line 3859 "Terminal.c"
}

static gboolean
terminal_terminal_do_paste_from_selection_clipboard_co (TerminalTerminalDoPasteFromSelectionClipboardData* _data_)
{
#line 735 "../src/widgets/Terminal.vala"
	switch (_data_->_state_) {
#line 735 "../src/widgets/Terminal.vala"
		case 0:
#line 3869 "Terminal.c"
		goto _state_0;
#line 735 "../src/widgets/Terminal.vala"
		case 1:
#line 3873 "Terminal.c"
		goto _state_1;
		default:
#line 735 "../src/widgets/Terminal.vala"
		g_assert_not_reached ();
#line 3878 "Terminal.c"
	}
	_state_0:
#line 739 "../src/widgets/Terminal.vala"
	_data_->_tmp0_ = gdk_display_get_default ();
#line 739 "../src/widgets/Terminal.vala"
	_data_->_tmp1_ = gdk_display_get_primary_clipboard (_data_->_tmp0_);
#line 739 "../src/widgets/Terminal.vala"
	_data_->_tmp2_ = _g_object_ref0 (_data_->_tmp1_);
#line 739 "../src/widgets/Terminal.vala"
	_data_->clipboard = _data_->_tmp2_;
#line 3889 "Terminal.c"
	{
#line 741 "../src/widgets/Terminal.vala"
		_data_->_state_ = 1;
#line 741 "../src/widgets/Terminal.vala"
		gdk_clipboard_read_text_async (_data_->clipboard, NULL, terminal_terminal_do_paste_from_selection_clipboard_ready, _data_);
#line 741 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3897 "Terminal.c"
		_state_1:
#line 741 "../src/widgets/Terminal.vala"
		_data_->_tmp3_ = gdk_clipboard_read_text_finish (_data_->clipboard, _data_->_res_, &_data_->_inner_error0_);
#line 741 "../src/widgets/Terminal.vala"
		_data_->text = _data_->_tmp3_;
#line 741 "../src/widgets/Terminal.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3905 "Terminal.c"
			goto __catch0_g_error;
		}
#line 742 "../src/widgets/Terminal.vala"
		vte_terminal_paste_text ((VteTerminal*) _data_->self, _data_->text);
#line 740 "../src/widgets/Terminal.vala"
		_g_free0 (_data_->text);
#line 3912 "Terminal.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 740 "../src/widgets/Terminal.vala"
		_data_->e = _data_->_inner_error0_;
#line 740 "../src/widgets/Terminal.vala"
		_data_->_inner_error0_ = NULL;
#line 745 "../src/widgets/Terminal.vala"
		_data_->_tmp4_ = _data_->e;
#line 745 "../src/widgets/Terminal.vala"
		_data_->_tmp5_ = _data_->_tmp4_->message;
#line 745 "../src/widgets/Terminal.vala"
		g_warning ("Terminal.vala:745: %s", _data_->_tmp5_);
#line 740 "../src/widgets/Terminal.vala"
		_g_error_free0 (_data_->e);
#line 3929 "Terminal.c"
	}
	__finally0:
#line 740 "../src/widgets/Terminal.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 740 "../src/widgets/Terminal.vala"
		_g_object_unref0 (_data_->clipboard);
#line 740 "../src/widgets/Terminal.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 740 "../src/widgets/Terminal.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 740 "../src/widgets/Terminal.vala"
		g_object_unref (_data_->_async_result);
#line 740 "../src/widgets/Terminal.vala"
		return FALSE;
#line 3944 "Terminal.c"
	}
#line 735 "../src/widgets/Terminal.vala"
	_g_object_unref0 (_data_->clipboard);
#line 735 "../src/widgets/Terminal.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 735 "../src/widgets/Terminal.vala"
	if (_data_->_state_ != 0) {
#line 735 "../src/widgets/Terminal.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 735 "../src/widgets/Terminal.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3956 "Terminal.c"
		}
	}
#line 735 "../src/widgets/Terminal.vala"
	g_object_unref (_data_->_async_result);
#line 735 "../src/widgets/Terminal.vala"
	return FALSE;
#line 3963 "Terminal.c"
}

gchar*
terminal_terminal_get_current_working_directory (TerminalTerminal* self)
{
	gchar* cwd = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 749 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 750 "../src/widgets/Terminal.vala"
	_tmp0_ = vte_terminal_get_current_directory_uri ((VteTerminal*) self);
#line 750 "../src/widgets/Terminal.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 750 "../src/widgets/Terminal.vala"
	cwd = _tmp1_;
#line 752 "../src/widgets/Terminal.vala"
	_tmp2_ = cwd;
#line 752 "../src/widgets/Terminal.vala"
	if (_tmp2_ != NULL) {
#line 3987 "Terminal.c"
		{
			gchar* path = NULL;
			const gchar* _tmp3_;
			gchar* _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_;
#line 754 "../src/widgets/Terminal.vala"
			_tmp3_ = cwd;
#line 754 "../src/widgets/Terminal.vala"
			_tmp4_ = g_filename_from_uri (_tmp3_, NULL, &_inner_error0_);
#line 754 "../src/widgets/Terminal.vala"
			path = _tmp4_;
#line 754 "../src/widgets/Terminal.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 754 "../src/widgets/Terminal.vala"
				if (_inner_error0_->domain == G_CONVERT_ERROR) {
#line 4004 "Terminal.c"
					goto __catch0_g_convert_error;
				}
#line 754 "../src/widgets/Terminal.vala"
				_g_free0 (cwd);
#line 754 "../src/widgets/Terminal.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 754 "../src/widgets/Terminal.vala"
				g_clear_error (&_inner_error0_);
#line 754 "../src/widgets/Terminal.vala"
				return NULL;
#line 4015 "Terminal.c"
			}
#line 755 "../src/widgets/Terminal.vala"
			_tmp5_ = path;
#line 755 "../src/widgets/Terminal.vala"
			_tmp6_ = g_strdup (_tmp5_);
#line 755 "../src/widgets/Terminal.vala"
			_g_free0 (cwd);
#line 755 "../src/widgets/Terminal.vala"
			cwd = _tmp6_;
#line 753 "../src/widgets/Terminal.vala"
			_g_free0 (path);
#line 4027 "Terminal.c"
		}
		goto __finally0;
		__catch0_g_convert_error:
		{
			GError* e = NULL;
			GError* _tmp7_;
			const gchar* _tmp8_;
#line 753 "../src/widgets/Terminal.vala"
			e = _inner_error0_;
#line 753 "../src/widgets/Terminal.vala"
			_inner_error0_ = NULL;
#line 758 "../src/widgets/Terminal.vala"
			_tmp7_ = e;
#line 758 "../src/widgets/Terminal.vala"
			_tmp8_ = _tmp7_->message;
#line 758 "../src/widgets/Terminal.vala"
			g_warning ("Terminal.vala:758: %s", _tmp8_);
#line 759 "../src/widgets/Terminal.vala"
			_g_free0 (cwd);
#line 759 "../src/widgets/Terminal.vala"
			cwd = NULL;
#line 753 "../src/widgets/Terminal.vala"
			_g_error_free0 (e);
#line 4051 "Terminal.c"
		}
		__finally0:
#line 753 "../src/widgets/Terminal.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 753 "../src/widgets/Terminal.vala"
			_g_free0 (cwd);
#line 753 "../src/widgets/Terminal.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 753 "../src/widgets/Terminal.vala"
			g_clear_error (&_inner_error0_);
#line 753 "../src/widgets/Terminal.vala"
			return NULL;
#line 4064 "Terminal.c"
		}
	}
#line 763 "../src/widgets/Terminal.vala"
	result = cwd;
#line 763 "../src/widgets/Terminal.vala"
	return result;
#line 4071 "Terminal.c"
}

gchar*
terminal_terminal_get_current_working_directory_for_new_session (TerminalTerminal* previous_terminal)
{
	TerminalSettings* settings = NULL;
	TerminalSettings* _tmp0_;
	guint mode = 0U;
	TerminalSettings* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	gchar* custom_working_directory = NULL;
	TerminalSettings* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 769 "../src/widgets/Terminal.vala"
	_tmp0_ = terminal_settings_get_default ();
#line 769 "../src/widgets/Terminal.vala"
	settings = _tmp0_;
#line 770 "../src/widgets/Terminal.vala"
	_tmp1_ = settings;
#line 770 "../src/widgets/Terminal.vala"
	_tmp2_ = terminal_settings_get_working_directory_mode (_tmp1_);
#line 770 "../src/widgets/Terminal.vala"
	_tmp3_ = _tmp2_;
#line 770 "../src/widgets/Terminal.vala"
	mode = _tmp3_;
#line 771 "../src/widgets/Terminal.vala"
	_tmp4_ = settings;
#line 771 "../src/widgets/Terminal.vala"
	_tmp5_ = terminal_settings_get_custom_working_directory (_tmp4_);
#line 771 "../src/widgets/Terminal.vala"
	_tmp6_ = _tmp5_;
#line 771 "../src/widgets/Terminal.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 771 "../src/widgets/Terminal.vala"
	custom_working_directory = _tmp7_;
#line 773 "../src/widgets/Terminal.vala"
	switch (mode) {
#line 773 "../src/widgets/Terminal.vala"
		case TERMINAL_WORKING_DIRECTORY_MODE_CUSTOM:
#line 4115 "Terminal.c"
		{
#line 775 "../src/widgets/Terminal.vala"
			result = custom_working_directory;
#line 775 "../src/widgets/Terminal.vala"
			_g_object_unref0 (settings);
#line 775 "../src/widgets/Terminal.vala"
			return result;
#line 4123 "Terminal.c"
		}
#line 773 "../src/widgets/Terminal.vala"
		case TERMINAL_WORKING_DIRECTORY_MODE_HOME_DIRECTORY:
#line 4127 "Terminal.c"
		{
			const gchar* _tmp8_;
			gchar* _tmp9_;
#line 777 "../src/widgets/Terminal.vala"
			_tmp8_ = g_get_home_dir ();
#line 777 "../src/widgets/Terminal.vala"
			_tmp9_ = g_strdup (_tmp8_);
#line 777 "../src/widgets/Terminal.vala"
			result = _tmp9_;
#line 777 "../src/widgets/Terminal.vala"
			_g_free0 (custom_working_directory);
#line 777 "../src/widgets/Terminal.vala"
			_g_object_unref0 (settings);
#line 777 "../src/widgets/Terminal.vala"
			return result;
#line 4143 "Terminal.c"
		}
#line 773 "../src/widgets/Terminal.vala"
		case TERMINAL_WORKING_DIRECTORY_MODE_PREVIOUS_SESSION:
#line 4147 "Terminal.c"
		{
			{
#line 779 "../src/widgets/Terminal.vala"
				if (previous_terminal != NULL) {
#line 4152 "Terminal.c"
					gchar* _tmp10_;
#line 780 "../src/widgets/Terminal.vala"
					_tmp10_ = terminal_terminal_get_current_working_directory (previous_terminal);
#line 780 "../src/widgets/Terminal.vala"
					result = _tmp10_;
#line 780 "../src/widgets/Terminal.vala"
					_g_free0 (custom_working_directory);
#line 780 "../src/widgets/Terminal.vala"
					_g_object_unref0 (settings);
#line 780 "../src/widgets/Terminal.vala"
					return result;
#line 4164 "Terminal.c"
				}
#line 782 "../src/widgets/Terminal.vala"
				break;
#line 4168 "Terminal.c"
			}
		}
		default:
#line 773 "../src/widgets/Terminal.vala"
		break;
#line 4174 "Terminal.c"
	}
#line 786 "../src/widgets/Terminal.vala"
	result = NULL;
#line 786 "../src/widgets/Terminal.vala"
	_g_free0 (custom_working_directory);
#line 786 "../src/widgets/Terminal.vala"
	_g_object_unref0 (settings);
#line 786 "../src/widgets/Terminal.vala"
	return result;
#line 4184 "Terminal.c"
}

void
terminal_terminal_on_before_close (TerminalTerminal* self)
{
#line 789 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 790 "../src/widgets/Terminal.vala"
	terminal_terminal_withdraw_command_completed_notification (self);
#line 4194 "Terminal.c"
}

TerminalScheme*
terminal_terminal_get_scheme (TerminalTerminal* self)
{
	TerminalScheme* result;
	TerminalScheme* _tmp0_;
#line 56 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../src/widgets/Terminal.vala"
	_tmp0_ = self->priv->_scheme;
#line 56 "../src/widgets/Terminal.vala"
	result = _tmp0_;
#line 56 "../src/widgets/Terminal.vala"
	return result;
#line 4210 "Terminal.c"
}

void
terminal_terminal_set_scheme (TerminalTerminal* self,
                              TerminalScheme* value)
{
	TerminalScheme* old_value;
#line 56 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/widgets/Terminal.vala"
	old_value = terminal_terminal_get_scheme (self);
#line 56 "../src/widgets/Terminal.vala"
	if (old_value != value) {
#line 4224 "Terminal.c"
		TerminalScheme* _tmp0_;
#line 56 "../src/widgets/Terminal.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 56 "../src/widgets/Terminal.vala"
		_g_object_unref0 (self->priv->_scheme);
#line 56 "../src/widgets/Terminal.vala"
		self->priv->_scheme = _tmp0_;
#line 56 "../src/widgets/Terminal.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_properties[TERMINAL_TERMINAL_SCHEME_PROPERTY]);
#line 4234 "Terminal.c"
	}
}

GPid
terminal_terminal_get_pid (TerminalTerminal* self)
{
	GPid result;
#line 57 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 57 "../src/widgets/Terminal.vala"
	result = self->priv->_pid;
#line 57 "../src/widgets/Terminal.vala"
	return result;
#line 4248 "Terminal.c"
}

void
terminal_terminal_set_pid (TerminalTerminal* self,
                           GPid value)
{
	GPid old_value;
#line 57 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/widgets/Terminal.vala"
	old_value = terminal_terminal_get_pid (self);
#line 57 "../src/widgets/Terminal.vala"
	if (old_value != value) {
#line 57 "../src/widgets/Terminal.vala"
		self->priv->_pid = value;
#line 57 "../src/widgets/Terminal.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_properties[TERMINAL_TERMINAL_PID_PROPERTY]);
#line 4266 "Terminal.c"
	}
}

TerminalProcess*
terminal_terminal_get_process (TerminalTerminal* self)
{
	TerminalProcess* result;
	TerminalProcess* _tmp0_;
#line 58 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "../src/widgets/Terminal.vala"
	_tmp0_ = self->priv->_process;
#line 58 "../src/widgets/Terminal.vala"
	result = _tmp0_;
#line 58 "../src/widgets/Terminal.vala"
	return result;
#line 4283 "Terminal.c"
}

void
terminal_terminal_set_process (TerminalTerminal* self,
                               TerminalProcess* value)
{
	TerminalProcess* old_value;
#line 58 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/widgets/Terminal.vala"
	old_value = terminal_terminal_get_process (self);
#line 58 "../src/widgets/Terminal.vala"
	if (old_value != value) {
#line 4297 "Terminal.c"
		TerminalProcess* _tmp0_;
#line 58 "../src/widgets/Terminal.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 58 "../src/widgets/Terminal.vala"
		_g_object_unref0 (self->priv->_process);
#line 58 "../src/widgets/Terminal.vala"
		self->priv->_process = _tmp0_;
#line 58 "../src/widgets/Terminal.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_properties[TERMINAL_TERMINAL_PROCESS_PROPERTY]);
#line 4307 "Terminal.c"
	}
}

guint
terminal_terminal_get_id (TerminalTerminal* self)
{
	guint result;
#line 59 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 59 "../src/widgets/Terminal.vala"
	result = self->priv->_id;
#line 59 "../src/widgets/Terminal.vala"
	return result;
#line 4321 "Terminal.c"
}

static void
terminal_terminal_set_id (TerminalTerminal* self,
                          guint value)
{
	guint old_value;
#line 59 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/widgets/Terminal.vala"
	old_value = terminal_terminal_get_id (self);
#line 59 "../src/widgets/Terminal.vala"
	if (old_value != value) {
#line 59 "../src/widgets/Terminal.vala"
		self->priv->_id = value;
#line 59 "../src/widgets/Terminal.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_properties[TERMINAL_TERMINAL_ID_PROPERTY]);
#line 4339 "Terminal.c"
	}
}

gboolean
terminal_terminal_get_needs_attention (TerminalTerminal* self)
{
	gboolean result;
#line 62 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 62 "../src/widgets/Terminal.vala"
	result = self->priv->_needs_attention;
#line 62 "../src/widgets/Terminal.vala"
	return result;
#line 4353 "Terminal.c"
}

void
terminal_terminal_set_needs_attention (TerminalTerminal* self,
                                       gboolean value)
{
	gboolean old_value;
#line 63 "../src/widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 63 "../src/widgets/Terminal.vala"
	old_value = terminal_terminal_get_needs_attention (self);
#line 63 "../src/widgets/Terminal.vala"
	if (old_value != value) {
#line 63 "../src/widgets/Terminal.vala"
		self->priv->_needs_attention = value;
#line 63 "../src/widgets/Terminal.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_terminal_properties[TERMINAL_TERMINAL_NEEDS_ATTENTION_PROPERTY]);
#line 4371 "Terminal.c"
	}
}

guint
terminal_terminal_get_user_scrollback_lines (TerminalTerminal* self)
{
	guint result;
	TerminalSettings* settings = NULL;
	TerminalSettings* _tmp0_;
	TerminalSettings* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
#line 68 "../src/widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 69 "../src/widgets/Terminal.vala"
	_tmp0_ = terminal_settings_get_default ();
#line 69 "../src/widgets/Terminal.vala"
	settings = _tmp0_;
#line 71 "../src/widgets/Terminal.vala"
	_tmp1_ = settings;
#line 71 "../src/widgets/Terminal.vala"
	_tmp2_ = terminal_settings_get_scrollback_mode (_tmp1_);
#line 71 "../src/widgets/Terminal.vala"
	_tmp3_ = _tmp2_;
#line 71 "../src/widgets/Terminal.vala"
	switch (_tmp3_) {
#line 71 "../src/widgets/Terminal.vala"
		case TERMINAL_SCROLLBACK_MODE_FIXED:
#line 4400 "Terminal.c"
		{
			TerminalSettings* _tmp4_;
			guint _tmp5_;
			guint _tmp6_;
#line 72 "../src/widgets/Terminal.vala"
			_tmp4_ = settings;
#line 72 "../src/widgets/Terminal.vala"
			_tmp5_ = terminal_settings_get_scrollback_lines (_tmp4_);
#line 72 "../src/widgets/Terminal.vala"
			_tmp6_ = _tmp5_;
#line 72 "../src/widgets/Terminal.vala"
			result = _tmp6_;
#line 72 "../src/widgets/Terminal.vala"
			_g_object_unref0 (settings);
#line 72 "../src/widgets/Terminal.vala"
			return result;
#line 4417 "Terminal.c"
		}
#line 71 "../src/widgets/Terminal.vala"
		case TERMINAL_SCROLLBACK_MODE_UNLIMITED:
#line 4421 "Terminal.c"
		{
#line 73 "../src/widgets/Terminal.vala"
			result = (guint) -1;
#line 73 "../src/widgets/Terminal.vala"
			_g_object_unref0 (settings);
#line 73 "../src/widgets/Terminal.vala"
			return result;
#line 4429 "Terminal.c"
		}
#line 71 "../src/widgets/Terminal.vala"
		case TERMINAL_SCROLLBACK_MODE_DISABLED:
#line 4433 "Terminal.c"
		{
#line 74 "../src/widgets/Terminal.vala"
			result = (guint) 0;
#line 74 "../src/widgets/Terminal.vala"
			_g_object_unref0 (settings);
#line 74 "../src/widgets/Terminal.vala"
			return result;
#line 4441 "Terminal.c"
		}
		default:
		{
			TerminalSettings* _tmp7_;
			guint _tmp8_;
			guint _tmp9_;
#line 76 "../src/widgets/Terminal.vala"
			_tmp7_ = settings;
#line 76 "../src/widgets/Terminal.vala"
			_tmp8_ = terminal_settings_get_scrollback_mode (_tmp7_);
#line 76 "../src/widgets/Terminal.vala"
			_tmp9_ = _tmp8_;
#line 76 "../src/widgets/Terminal.vala"
			g_error ("Terminal.vala:76: Invalid scrollback-mode %u", _tmp9_);
#line 4456 "Terminal.c"
		}
	}
}

static void
terminal_terminal_class_init (TerminalTerminalClass * klass,
                              gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
#line 21 "../src/widgets/Terminal.vala"
	terminal_terminal_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/widgets/Terminal.vala"
	g_type_class_adjust_private_offset (klass, &TerminalTerminal_private_offset);
#line 21 "../src/widgets/Terminal.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) terminal_terminal_real_dispose;
#line 21 "../src/widgets/Terminal.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_terminal_terminal_get_property;
#line 21 "../src/widgets/Terminal.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_terminal_terminal_set_property;
#line 21 "../src/widgets/Terminal.vala"
	G_OBJECT_CLASS (klass)->finalize = terminal_terminal_finalize;
#line 21 "../src/widgets/Terminal.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_SCHEME_PROPERTY, terminal_terminal_properties[TERMINAL_TERMINAL_SCHEME_PROPERTY] = g_param_spec_object ("scheme", "scheme", "scheme", TERMINAL_TYPE_SCHEME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/widgets/Terminal.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_PID_PROPERTY, terminal_terminal_properties[TERMINAL_TERMINAL_PID_PROPERTY] = g_param_spec_int ("pid", "pid", "pid", G_MININT, G_MAXINT, (GPid) -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/widgets/Terminal.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_PROCESS_PROPERTY, terminal_terminal_properties[TERMINAL_TERMINAL_PROCESS_PROPERTY] = g_param_spec_object ("process", "process", "process", TERMINAL_TYPE_PROCESS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/widgets/Terminal.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_ID_PROPERTY, terminal_terminal_properties[TERMINAL_TERMINAL_ID_PROPERTY] = g_param_spec_uint ("id", "id", "id", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/widgets/Terminal.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_NEEDS_ATTENTION_PROPERTY, terminal_terminal_properties[TERMINAL_TERMINAL_NEEDS_ATTENTION_PROPERTY] = g_param_spec_boolean ("needs-attention", "needs-attention", "needs-attention", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/widgets/Terminal.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_TERMINAL_USER_SCROLLBACK_LINES_PROPERTY, terminal_terminal_properties[TERMINAL_TERMINAL_USER_SCROLLBACK_LINES_PROPERTY] = g_param_spec_uint ("user-scrollback-lines", "user-scrollback-lines", "user-scrollback-lines", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4497 "Terminal.c"
	/**
	   * This signal is emitted when the terminal process exits. Something should
	   * listen for this signal and close the tab that contains this terminal.
	   */
#line 21 "../src/widgets/Terminal.vala"
	terminal_terminal_signals[TERMINAL_TERMINAL_EXIT_SIGNAL] = g_signal_new ("exit", TERMINAL_TYPE_TERMINAL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 21 "../src/widgets/Terminal.vala"
	terminal_terminal_signals[TERMINAL_TERMINAL_SPAWN_FAILED_SIGNAL] = g_signal_new ("spawn-failed", TERMINAL_TYPE_TERMINAL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 21 "../src/widgets/Terminal.vala"
	terminal_terminal_signals[TERMINAL_TERMINAL_CONTEXT_CHANGED_SIGNAL] = g_signal_new ("context-changed", TERMINAL_TYPE_TERMINAL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, TERMINAL_TYPE_PROCESS_CONTEXT);
#line 32 "../src/widgets/Terminal.vala"
	_tmp0_ = g_strdup ("TERM=xterm-256color");
#line 32 "../src/widgets/Terminal.vala"
	_tmp1_ = g_strdup ("COLORTERM=truecolor");
#line 32 "../src/widgets/Terminal.vala"
	_tmp2_ = g_strdup_printf ("TERM_PROGRAM=%s", TERMINAL_APP_NAME);
#line 32 "../src/widgets/Terminal.vala"
	_tmp3_ = terminal_constants_get_user_schemes_dir ();
#line 32 "../src/widgets/Terminal.vala"
	_tmp4_ = _tmp3_;
#line 32 "../src/widgets/Terminal.vala"
	_tmp5_ = g_strdup_printf ("BLACKBOX_THEMES_DIR=%s", _tmp4_);
#line 32 "../src/widgets/Terminal.vala"
	_tmp6_ = g_strdup_printf ("VTE_VERSION=%u", (guint) (((VTE_MAJOR_VERSION * 10000) + (VTE_MINOR_VERSION * 100)) + VTE_MICRO_VERSION));
#line 32 "../src/widgets/Terminal.vala"
	_tmp7_ = g_new0 (gchar*, 5 + 1);
#line 32 "../src/widgets/Terminal.vala"
	_tmp7_[0] = _tmp0_;
#line 32 "../src/widgets/Terminal.vala"
	_tmp7_[1] = _tmp1_;
#line 32 "../src/widgets/Terminal.vala"
	_tmp7_[2] = _tmp2_;
#line 32 "../src/widgets/Terminal.vala"
	_tmp7_[3] = _tmp5_;
#line 32 "../src/widgets/Terminal.vala"
	_tmp7_[4] = _tmp6_;
#line 32 "../src/widgets/Terminal.vala"
	terminal_terminal_blackbox_envv = _tmp7_;
#line 32 "../src/widgets/Terminal.vala"
	terminal_terminal_blackbox_envv_length1 = 5;
#line 32 "../src/widgets/Terminal.vala"
	_terminal_terminal_blackbox_envv_size_ = terminal_terminal_blackbox_envv_length1;
#line 4540 "Terminal.c"
}

static void
terminal_terminal_instance_init (TerminalTerminal * self,
                                 gpointer klass)
{
#line 21 "../src/widgets/Terminal.vala"
	self->priv = terminal_terminal_get_instance_private (self);
#line 57 "../src/widgets/Terminal.vala"
	self->priv->_pid = (GPid) -1;
#line 58 "../src/widgets/Terminal.vala"
	self->priv->_process = NULL;
#line 61 "../src/widgets/Terminal.vala"
	self->priv->_needs_attention = FALSE;
#line 85 "../src/widgets/Terminal.vala"
	self->priv->fp_spawn_host_command_callback_cancellable = NULL;
#line 87 "../src/widgets/Terminal.vala"
	self->priv->attention_timer = (guint) 0;
#line 253 "../src/widgets/Terminal.vala"
	self->priv->padding_provider = NULL;
#line 4561 "Terminal.c"
}

static void
terminal_terminal_finalize (GObject * obj)
{
	TerminalTerminal * self;
#line 21 "../src/widgets/Terminal.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_TERMINAL, TerminalTerminal);
#line 56 "../src/widgets/Terminal.vala"
	_g_object_unref0 (self->priv->_scheme);
#line 58 "../src/widgets/Terminal.vala"
	_g_object_unref0 (self->priv->_process);
#line 83 "../src/widgets/Terminal.vala"
	_g_object_unref0 (self->window);
#line 85 "../src/widgets/Terminal.vala"
	_g_object_unref0 (self->priv->fp_spawn_host_command_callback_cancellable);
#line 91 "../src/widgets/Terminal.vala"
	_g_object_unref0 (self->priv->settings);
#line 253 "../src/widgets/Terminal.vala"
	_g_object_unref0 (self->priv->padding_provider);
#line 21 "../src/widgets/Terminal.vala"
	G_OBJECT_CLASS (terminal_terminal_parent_class)->finalize (obj);
#line 4584 "Terminal.c"
}

static GType
terminal_terminal_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminalTerminalClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_terminal_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalTerminal), 0, (GInstanceInitFunc) terminal_terminal_instance_init, NULL };
	GType terminal_terminal_type_id;
	terminal_terminal_type_id = g_type_register_static (vte_terminal_get_type (), "TerminalTerminal", &g_define_type_info, 0);
	TerminalTerminal_private_offset = g_type_add_instance_private (terminal_terminal_type_id, sizeof (TerminalTerminalPrivate));
	return terminal_terminal_type_id;
}

GType
terminal_terminal_get_type (void)
{
	static volatile gsize terminal_terminal_type_id__once = 0;
	if (g_once_init_enter (&terminal_terminal_type_id__once)) {
		GType terminal_terminal_type_id;
		terminal_terminal_type_id = terminal_terminal_get_type_once ();
		g_once_init_leave (&terminal_terminal_type_id__once, terminal_terminal_type_id);
	}
	return terminal_terminal_type_id__once;
}

static void
_vala_terminal_terminal_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	TerminalTerminal * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_TERMINAL, TerminalTerminal);
#line 21 "../src/widgets/Terminal.vala"
	switch (property_id) {
#line 21 "../src/widgets/Terminal.vala"
		case TERMINAL_TERMINAL_SCHEME_PROPERTY:
#line 21 "../src/widgets/Terminal.vala"
		g_value_set_object (value, terminal_terminal_get_scheme (self));
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 21 "../src/widgets/Terminal.vala"
		case TERMINAL_TERMINAL_PID_PROPERTY:
#line 21 "../src/widgets/Terminal.vala"
		g_value_set_int (value, terminal_terminal_get_pid (self));
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 21 "../src/widgets/Terminal.vala"
		case TERMINAL_TERMINAL_PROCESS_PROPERTY:
#line 21 "../src/widgets/Terminal.vala"
		g_value_set_object (value, terminal_terminal_get_process (self));
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 21 "../src/widgets/Terminal.vala"
		case TERMINAL_TERMINAL_ID_PROPERTY:
#line 21 "../src/widgets/Terminal.vala"
		g_value_set_uint (value, terminal_terminal_get_id (self));
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 21 "../src/widgets/Terminal.vala"
		case TERMINAL_TERMINAL_NEEDS_ATTENTION_PROPERTY:
#line 21 "../src/widgets/Terminal.vala"
		g_value_set_boolean (value, terminal_terminal_get_needs_attention (self));
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 21 "../src/widgets/Terminal.vala"
		case TERMINAL_TERMINAL_USER_SCROLLBACK_LINES_PROPERTY:
#line 21 "../src/widgets/Terminal.vala"
		g_value_set_uint (value, terminal_terminal_get_user_scrollback_lines (self));
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 4655 "Terminal.c"
		default:
#line 21 "../src/widgets/Terminal.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 4661 "Terminal.c"
	}
}

static void
_vala_terminal_terminal_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	TerminalTerminal * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_TERMINAL, TerminalTerminal);
#line 21 "../src/widgets/Terminal.vala"
	switch (property_id) {
#line 21 "../src/widgets/Terminal.vala"
		case TERMINAL_TERMINAL_SCHEME_PROPERTY:
#line 21 "../src/widgets/Terminal.vala"
		terminal_terminal_set_scheme (self, g_value_get_object (value));
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 21 "../src/widgets/Terminal.vala"
		case TERMINAL_TERMINAL_PID_PROPERTY:
#line 21 "../src/widgets/Terminal.vala"
		terminal_terminal_set_pid (self, g_value_get_int (value));
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 21 "../src/widgets/Terminal.vala"
		case TERMINAL_TERMINAL_PROCESS_PROPERTY:
#line 21 "../src/widgets/Terminal.vala"
		terminal_terminal_set_process (self, g_value_get_object (value));
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 21 "../src/widgets/Terminal.vala"
		case TERMINAL_TERMINAL_ID_PROPERTY:
#line 21 "../src/widgets/Terminal.vala"
		terminal_terminal_set_id (self, g_value_get_uint (value));
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 21 "../src/widgets/Terminal.vala"
		case TERMINAL_TERMINAL_NEEDS_ATTENTION_PROPERTY:
#line 21 "../src/widgets/Terminal.vala"
		terminal_terminal_set_needs_attention (self, g_value_get_boolean (value));
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 4705 "Terminal.c"
		default:
#line 21 "../src/widgets/Terminal.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/widgets/Terminal.vala"
		break;
#line 4711 "Terminal.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

